if(!dojo._hasResource["com.ibm.customize.MashupsAddContentController"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.customize.MashupsAddContentController"] = true;
 // This is a controller that customizes the content on a page

dojo.provide("com.ibm.customize.MashupsAddContentController");
dojo.require("com.ibm.data.JsonStore");
dojo.require("com.ibm.data.MashupCatalogFeedStore");

com.ibm.customize.MashupsAddContentController = {
	eventService: null,
	
	filterAdd: function(map){
		if(map.type == "mashup" || map.type == "iwidgetURL" || map.type == "feed" || !map.type) return true
		else return false;
	},

/***********************************************/
/*       Customize Controller API			   */
/***********************************************/

	parent: null,		// a pointer to this controller's parent, if one exists
	dirty: false,		// true if there are changes pending
	added: false,		// true if there were widgets added
	started: false,		// true if the widget is started up
	refresh: false,		// true if a page refresh is required to show saved changes

	startup: function(/*Object/Widget*/parent){		
		// get predefined renderers from the catalog model
		var renderers = [];
		var priorityRenderers = [];
		var catModel = com.ibm.mm.builder.utils.toolboxUtil.getCatalogModel();
		var catIterator = catModel.getChildren();
		while(catIterator.hasNext()) {
			var categoryModel = catModel.getCatalogEntryModel(catIterator.next());
			var elemIterator = categoryModel.iterator();
			elemIterator.setCursorPosition(0);
			while (elemIterator.hasNext()){
				var entry = elemIterator.next();
				priority = entry.getMetadata("com.ibm.lotus.widget.renderer");
				if(priority == "priority") priorityRenderers.push({id:entry.getID(),label:com.ibm.mm.builder.utils.enablerUtil.getNodeTitle(entry)});
				else renderers.push({id:entry.getID(),label:com.ibm.mm.builder.utils.enablerUtil.getNodeTitle(entry)});
			}
		}
		this.renderers = priorityRenderers.concat(renderers);
		
		this.started = true;
		this.parent = parent;
		this.setupUI();
	},

	makeDirty: function(/*bool*/change){
		// summary: changes the dirty attribute
		// change: value to assign to the dirty attribute
		this.dirty = change;
	},

	processChange: function(/*Object*/args){
		// summary: used as an event handler for when a user clicks on a result
		// args: 	id: the unique id of the piece of content
		//			label: the display name of the piece of content
		//			fcn (optional): a function or the name of a function in dot notation which retrieves a map of the preferences for the piece of content
		//			map (optional): an object of parameters to be passed to fcn
		//			takeoverFcn (optional): a function or the name of a function in dot notation which will be run instead of the body of this submit function
		//			takeoverObject (optional): an object of parameters to be passed to takeoverFcn
				
		// check for takeover function
		if(args.takeoverFcn) {
			if(dojo.isString(args.takeoverFcn)) dojo.getObject(args.takeoverFcn)(args.takeoverObject);
			else args.takeoverFcn(args.takeoverObject);
			return;
		}
		this.apply(args);
		if(!this.parent) this.beforeSubmit().addCallback(dojo.hitch(this, function(){this.submit(args)}));
	},

	apply: function(/*Object*/args){
		if(!this.dirty) this.makeDirty(true);
		var data = args.map;
		if(data.type == "feed" || data.type == "mashup"){
			var ieventArgs = {};
			ieventArgs.id = args.id;
			ieventArgs.itemSet = {};
			ieventArgs.itemSet.feedURL = data.url;			// feed reader and data viewer
			ieventArgs.itemSet.dataSourceURL = data.url;	// chart
			this.eventService.broadcastEvent("com.ibm.mashups.builder.addWidget",ieventArgs);
		} else if (data.type == "iwidgetURL"){
			dojo.xhrGet ({
		        url: this.createProxyURI(data.url),
		        load: dojo.hitch(this, function(xml){
					var start = xml.indexOf('url');
					var end = xml.indexOf('xml');
					if(start < 0 || end < 0) return;
					var definitionURL = xml.substring(start+4,end+3);
					var ieventArgs = {};
					ieventArgs.widgetMetadata = {};
					ieventArgs.widgetMetadata.id = args.id;
					ieventArgs.widgetMetadata.definition = definitionURL;
					ieventArgs.widgetMetadata.icon = data.icon;
					ieventArgs.widgetMetadata.title = {}; ieventArgs.widgetMetadata.title[djConfig.locale] = args.label;
					ieventArgs.widgetMetadata.onNewWire = "";
					var feedWidgetParam = data.widgetParam;
					if (feedWidgetParam && feedWidgetParam.length > 2 && feedWidgetParam.charAt(0) == '[') {
						// widgetParam is defined
						ieventArgs.widgetMetadata.widgetParam = feedWidgetParam;
					} else {
						ieventArgs.widgetMetadata.widgetParam = "[]";
					}
					this.eventService.broadcastEvent("com.ibm.mashups.builder.addWidget",ieventArgs);
				}),
				error: function(e){
					console.error(e);
				}
			});
		} else {
			this.eventService.broadcastEvent("com.ibm.mashups.builder.addWidget",data.id);
		}
	},

	undo: function(/*Object*/args){ 
		// refresh the page so the unsaved widgets will be removed from the DOM
		var pageId = com.ibm.mm.builder.utils.pageUtil.getCurrentPageId();
		this.eventService.broadcastEvent("com.ibm.mashups.builder.switchPage", pageId);
	},

	beforeSubmit: function(/*Object*/args){
		var dfd = new dojo.Deferred();
		dfd.callback();
		return dfd;
	},

	submit: function(/*Object*/args){
		// summary: saves any pending changes to the server
		// args: may contain an onComplete handler
		if(this.dirty) this.makeDirty(false);
		if(args.onComplete) args.onComplete();
	}
}

}
