if(!dojo._hasResource["com.ibm.data.AtomFeedStore"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.data.AtomFeedStore"] = true;
dojo.provide( "com.ibm.data.AtomFeedStore" );

dojo.require( "com.ibm.data.XpathHelper" );
dojo.require( "dojo.date.stamp" );

dojo.declare( "com.ibm.data.AtomFeedStore",
			com.ibm.data.XpathHelper,
			{
				// namespaces: Map
				//		Map of namespaces used by the ATOM feeds
				namespaces: {
		            "atom" : "http://www.w3.org/2005/Atom"
		        },
		        // _features: Map
				//		Map of features that this store supports.
				//		This generic AtomFeedStore only supports Read and Identity.
				_features: {
					'dojo.data.api.Read': true,
					'dojo.data.api.Write': false,
					'dojo.data.api.Identity': false,
					'dojo.data.api.Notification': false
				},
				attrMappings: {
					title: {xpath: "./atom:title", targetName: "textContent", type: "node", setter: 
						function(item, rule, value){
							var elem = this._createNSElement(item.element.ownerDocument, "atom:title");
							this._setNodeProp(elem, rule.targetName, value);
							item.element.appendChild(elem);
							return true;
						}
					},
					id: {xpath: "./atom:id", targetName: "textContent", type: "node", setter: 
						function(item, rule, value){
							var elem = this._createNSElement(item.element.ownerDocument, "atom:id");
							this._setNodeProp(elem, rule.targetName, value);
							item.element.appendChild(elem);
							return true;
						}
					},
					updated: {xpath: "./atom:updated", targetName: "AtomDateConstruct", type: "node"},
					category: {xpath: "./atom:category", targetName: "term", type: "attr", setter: 
						function(item, rule, value){
							var elem = this._createNSElement(item.element.ownerDocument, "atom:category");
							this._setAttribute(elem, rule.targetName, value);
							item.element.appendChild(elem);
							return true;
						}
					},
					categoryScheme: {xpath: "./atom:category", targetName: "scheme", type: "attr", setter: 
						function(item, rule, value){
							var elem = this._createNSElement(item.element.ownerDocument, "atom:category");
							this._setAttribute(elem, rule.targetName, value);
							item.element.appendChild(elem);
							return true;
						}
					},
					categoryLabel: {xpath: "./atom:category", targetName: "label", type: "attr", setter: 
						function(item, rule, value){
							var elem = this._createNSElement(item.element.ownerDocument, "atom:category");
							this._setAttribute(elem, rule.targetName, value);
							item.element.appendChild(elem);
							return true;
						}
					},
					contributer: {xpath: "./atom:contributer", targetName: "AtomPersonConstruct", type: "node"},
					author: {xpath: "./atom:author", targetName: "AtomPersonConstruct", type: "node"},
					summary: {xpath: "./atom:summary", targetName: "textContent", type: "node", setter: 
						function(item, rule, value){
							var elem = this._createNSElement(item.element.ownerDocument, "atom:summary");
							this._setNodeProp(elem, rule.targetName, value);
							item.element.appendChild(elem);
							return true;
						}
					},
					source: {xpath: "./atom:source", type: "node", setter: 
						function(item, rule, value){
							item.element.appendChild(value);
							return true;
						}
					},
					rights: {xpath: "./atom:rights", targetName: "textContent", type: "node", setter: 
						function(item, rule, value){
							var elem = this._createNSElement(item.element.ownerDocument, "atom:rights");
							this._setNodeProp(elem, rule.targetName, value);
							item.element.appendChild(elem);
							return true;
						}
					},
					selfLink: {xpath: "./atom:link[@rel='self']", targetName: "href", type: "attr", setter: 
						function(item, rule, value){
							var elem = this._createNSElement(item.element.ownerDocument, "atom:link");
							this._setAttribute(elem, "rel", "self");
							this._setAttribute(elem, rule.targetName, value);
							item.element.appendChild(elem);
							return true;
						}
					},
					link: {xpath: "./atom:link[@href]", targetName: "href", type: "attr", setter: 
						function(item, rule, value){
							var elem = this._createNSElement(item.element.ownerDocument, "atom:link");
							this._setAttribute(elem, rule.targetName, value);
							item.element.appendChild(elem);
							return true;
						}
					},
					content: {xpath: "./atom:content", type: "node", setter: 
						function(item, rule, value){
							item.element.appendChild(value);
							return true;
						}
					}
				},
				
				// timeout: Number milliseconds to wait for a response for any request
				//		sent by this data store.
				timeout: null,
				
				// itemClass: String the class used to represent items of this store
				itemClass: "com.ibm.data.AtomEntryItem",
								
				constructor: function( /*Map*/ args ) {
					// summary: Creates a new instance of a com.ibm.data.AtomFeedStore
					// args: Map
					//		The args map will be used to replace any default values of this store with the
					//		values specified in the args map.
					dojo.mixin(this, args);
					this._dirtyItems = [];
					this._deletedItems = [];
					this._newItems = [];
				},
				toString: function() {
					return "<" + this.__getClassName() + ": " + this.url + ">";
				},
				handleConstructs: function(/*DOMNode*/ node, /*String*/ prop) {
					switch(prop) {
						case "AtomPersonConstruct": return new com.ibm.data.AtomPersonConstruct(node);
						case "AtomDateConstruct": return new com.ibm.data.AtomDateConstruct(node);
						default: return this.inherited(arguments);
					}
				},
				
				_assertIsItem: function(/*Object*/ something) {
					// summary: Throws an exception if the argument is not a valid item in this store.
					// something: Object to check to determine if it is an item in this store.
					if (!this.isItem(something)) {
						throw new Error(something + " is not an item in this store");
					}
					return true;
				},
				_assertIsString: function(/*Object*/ something) {
					// summary: Throws an exception if the argument is not a string.
					// something: Object to check to determine if it is a string.
					if (!dojo.isString(something)) {
						throw new Error(something + " is not a string");
					}
					return true;
				},
				_getItem: function(args) {
					// summary: Overridable function to create a new item in this store based on the args map.
					var cls = this.itemClass;
					if(dojo.isString(cls)) {
						cls = dojo.getObject(this.itemClass);
					}
					return new cls({store: this, element: args.element, loaded: true}); 
				},
				/********************************/
				/**                            **/
				/**                            **/
				/**    		 Public  		   **/
				/**                            **/
				/**                            **/
				/********************************/
								
				getFeedValue: function( /*String*/ attribute, /*Value?*/ defaultValue) {
					var ret = defaultValue;
					this._assertIsString(attribute);
					var mapRule = this.getMapRule(attribute, this.attrMappings);
					// if mapRule is null here, then we couldn't find one in the map, 
					// so we can't proceed successfully
					if(mapRule) {
						ret = this.getValueByMapping(null, mapRule, defaultValue);
					}
					
					return ret;
				},
				getFeedValues: function( /*String*/ attribute) {
					var ret = [];
					this._assertIsString(attribute);
					var mapRule = this.getMapRule(attribute, this.attrMappings);
					// if mapRule is null here, then we couldn't find one in the map, 
					// so we can't proceed successfully
					if(mapRule) {
						ret = this.getValuesByMapping(null, mapRule);
					}
					
					return ret;
				},
				extractEmptyFeed: function() {
					var toClone = this._getNodeByXpath(this._feed, "//atom:feed").value;
					var feedDOM = toClone.cloneNode(false);
					// get all non-entry nodes
					var result = this._getNodesByXpath(toClone, "/atom:feed/*");
					var nodes = result.value;
					for(var i = 0; i < nodes.length; i++) {
						if(nodes[i].nodeName != "atom:entry") {
							feedDOM.appendChild(nodes[i].cloneNode(true));
						}
					}
					return feedDOM;
				},
				extractSingleEntryFeed: function(/* com.ibm.data.AtomEntryItem */ item ) {
					var ret = this.extractEmptyFeed();
					ret.appendChild(item.element.cloneNode(true));
					return ret;
				},
				extractMultipleEntryFeed: function(/* Array */ items ) {
					var ret = this.extractEmptyFeed();
					dojo.forEach(items, function(item){
						ret.appendChild(item.element.cloneNode(true));
					});
					return ret;
				},
				
				getEPResolvedValue: function(	/* com.ibm.data.AtomEntryItem */ item, 
						/* String */ attribute, 
						/* Value? */ defaultValue){
					var ret = null;
					if(this.hasAttribute(item, attribute)) {
						var mapRule = this.getMapRule(attribute, item.attrMappings);
						// if mapRule is null here, then we couldn't find one in the map, 
						// so we return the defaultValue 
						if (!mapRule) {
							return ret;
						}
						ret = this.getValueByMapping(item, mapRule, defaultValue);
					}
					if (!ret) {
						ret = defaultValue;
					}
					ret = com.ibm.mashups.enabler.utils.EndpointHelper.resolve(ret);
					return ret;
				},
								
				/********************************/
				/**                            **/
				/**                            **/
				/**   dojo.data.api.Identity   **/
				/**                            **/
				/**                            **/
				/********************************/				
				getIdentity: function(/* item */ item) {
					// summary: See dojo.data.api.Identity.getIdentity()
					// returns: The entry's unique identifier
					if (item._id) {
						return item._id;
					}
					// this is a common operation... so cache this on the item itself
					var attrs = this.getIdentityAttributes(item);
					var id = "";
					dojo.forEach(attrs, function(attr){
						id += this.getEPResolvedValue(item, attr, "");
					}, this);
					item._id = id;
					return id;
				},
				
				getIdentityAttributes: function(/* item */ item){
					//	summary:
					//		Returns an array of attribute names that are used to generate the identity. 
					//		For most stores, this is a single attribute, but for some complex stores
					//		such as RDB backed stores that use compound (multi-attribute) identifiers
					//		it can be more than one.  If the identity is not composed of attributes
					//		on the item, it will return null.  This function is intended to identify
					//		the attributes that comprise the identity so that so that during a render
					//		of all attributes, the UI can hide the the identity information if it 
					//		chooses.
					//	item:
					//		The item from the store from which to obtain the array of public attributes that 
					//		compose the identifier, if any.
					return ['id']; // Array
				},
			
				fetchItemByIdentity: function(/* object */ keywordArgs){
					//	summary:
					//		Given the identity of an item, this method returns the item that has 
					//		that identity through the onItem callback.  Conforming implementations 
					//		should return null if there is no item with the given identity.  
					//		Implementations of fetchItemByIdentity() may sometimes return an item 
					//		from a local cache and may sometimes fetch an item from a remote server, 
					//
					// 	keywordArgs:
					//		An anonymous object that defines the item to locate and callbacks to invoke when the 
					//		item has been located and load has completed.  The format of the object is as follows:
					//		{
					//			identity: string|object,
					//			onItem: Function,
					//			onError: Function,
					//			scope: object
					//		}
					//	The *identity* parameter.
					//		The identity parameter is the identity of the item you wish to locate and load
					//		This attribute is required.  It should be a string or an object that toString() 
					//		can be called on.
					//		
					//	The *onItem* parameter.
					//		Function(item)
					//		The onItem parameter is the callback to invoke when the item has been loaded.  It takes only one
					//		parameter, the item located, or null if none found.
					//
					//	The *onError* parameter.
					//		Function(error)
					//		The onError parameter is the callback to invoke when the item load encountered an error.  It takes only one
					//		parameter, the error object
					//
					//	The *scope* parameter.
					//		If a scope object is provided, all of the callback functions (onItem, 
					//		onError, etc) will be invoked in the context of the scope object.
					//		In the body of the callback function, the value of the "this"
					//		keyword will be the scope object.   If no scope object is provided,
					//		the callback functions will be called in the context of dojo.global.
					//		For example, onItem.call(scope, item, request) vs. 
					//		onItem.call(dojo.global, item, request)
					
					
					// not implemented by the AtomFeedStore since this supports generic Atom Feeds and therefore
					// can't generate a URL to get a particular item by its identity without additional knowledge
					// of how the feed URLs are created... however, this can be overridden by a application consuming
					// an instance of this store that does have knowledge of the particular feed URLs
					return false;
				},
				/********************************/
				/**                            **/
				/**                            **/
				/**     dojo.data.api.Read     **/
				/**                            **/
				/**                            **/
				/********************************/
				getValue: function(	/* com.ibm.data.AtomEntryItem */ item, 
						/* String */ attribute, 
						/* Value? */ defaultValue){
					var ret = null;
					if(this.hasAttribute(item, attribute)) {
						var mapRule = this.getMapRule(attribute, item.attrMappings);
						// if mapRule is null here, then we couldn't find one in the map, 
						// so we return the defaultValue 
						if (!mapRule) {
							return ret;
						}
						ret = this.getValueByMapping(item, mapRule, defaultValue);
					}
					if (!ret) {
						ret = defaultValue;
					}
					
					return ret;
				},
				
				getValues: function(/* com.ibm.data.AtomEntryItem */ item,
						/* String */ attribute){
					if(this.hasAttribute(item, attribute)) {
						var mapRule = this.getMapRule(attribute, item.attrMappings);
						// if mapRule is null here, then we couldn't find one in the map, 
						// so we return an empty list
						if (!mapRule) {
							return [];
						}
						return this.getValuesByMapping(item, mapRule);
					}
					return [];
				},
				_extractParameterizedMapKey: function( /*String*/ mapKey ) {
					// summary: Expands a mapKey and determines if it is a key to a parameterizable map rule.
					//		If it is, extract the parameters from the argument and return the base key name
					//		used to look up the correct map rule in this object's attrMappings without the parameter
					// 		values, and also return the parameters as an array of strings.  
					// 		If the mapKey is not the key of a parameterizable map rule, just return the key and a 
					// 		null parameter array.
					// returns: Object {key: stringMapKey, parameters: arrayOfParameterValues}
					if(mapKey.charAt(mapKey.length - 1) == '$') {
						var start = mapKey.indexOf('[');
						var end = mapKey.lastIndexOf(']');
						if(start > -1 && end > start) {
							var baseName = mapKey.substring(0, start) + "$";
							var parms = mapKey.substring(start + 1, end).split(',');
							return {key: baseName, parameters: parms};
						}
					}
					return {key: mapKey, parameters: null};
				},
				
				getMapRule: function( /*String*/ mapKey, /*Object*/map, /*Boolean?*/ multiValued ) {
					// summary: Takes a mapKey string that ends in '$' to key into this object's 
					// 		attrMappings, and then parameterizes the map it finds according
					// 		to the parameters found within the '[...]' block of the mapKey.
					// 		Example: A mapKey of 'localizedName[edward, tj]$' would lookup
					// 			the key 'localizedName$' in this.attrMappings.
					// 			The resulting map rule would be used as a template for the returned
					//			map rule.  The parameters used to parameterize the template would
					//			be ['edward', 'tj'] and would match the ${0} and ${1} parameters
					//			in the map rule respectively.
					// returns: The map rule specified by this mapKey after all parameters have been
					//			bound to their values as specified by the caller.
					var obj = this._extractParameterizedMapKey(mapKey);
					var rule = map[obj.key];
					
					if (!rule) {
						return rule;
					}
					// if this is not a parameterized map rule, just return the map rule as-is
					if(!obj.parameters) {
						rule._ruleKey = obj.key;
						return rule;
					}
					
					// otherwise, parameterize the map by using the array of parameters passed into the attribute
					// like this ->  attribute[parm1, parm2, parm3]$
					// parameterized attributes always end with $
					var expRule = {};
					for(var prop in rule) {
						if(dojo.isString(rule[prop])) {
							expRule[prop] = dojo.string.substitute(rule[prop], obj.parameters, function(part){
								return dojo.string.trim(part);
							});
						}
						else {
							expRule[prop] = rule[prop];
						}
					}
					expRule._parameters = obj.parameters;
					expRule._ruleKey = obj.key;
					expRule.multiValued = !!multiValued;
					return expRule;
				},
				
				getValuesByMapping: function( /* com.ibm.data.AtomEntryItem */ item, 
						/* Object */ mapping){
					// summary: Executes the correct query API using the mapping argument to
					//		retrieve the desired attribute value for the item as specified by the 
					// 		mapping.
					// mapping: A mapping object from this object's attrMappings
					var ret = null;
					var xpath = mapping.xpath;
					var type = mapping.type;
					var targetName = mapping.targetName;
					var context = this._feed;
					if(item) {
						this._assertIsItem(item);
						context = item.element;
					}
					if(type == "attr") {
						ret = this._getAttrsByXpath(context, xpath, targetName);
					}
					else {
						ret = this._getNodesByXpath(context, xpath, targetName);
					}
					
					if(!ret.found && item._backup) {
						// we didn't find any nodes matching the xpath query, and
						// this item has been copied from its original for modification,
						// so perhaps we explicitly removed it in the modified version for
						// performance reasons... so lets look it up in the original unmodified version						
						context = item._backup;
						if(type == "attr") {
							ret = this._getAttrsByXpath(context, xpath, targetName);
						}
						else {
							ret = this._getNodesByXpath(context, xpath, targetName);
						}
						
						// if ret.found is still false, then just return the defaultValue
						if (!ret.found) {
							ret.value = [];
						}
					}
					
					return ret.value;
				},
				
				getValueByMapping: function( /* com.ibm.data.AtomEntryItem */ item, 
						/* Object */ mapping, 
						/* Value? */ defaultValue){
					// summary: Executes the correct query API using the mapping argument to
					//		retrieve the desired attribute value for the item as specified by the 
					// 		mapping.
					// mapping: A mapping object from this object's attrMappings
					// defaultValue: The default value to return if no value exists for the mapping.
					//		If null is returned by the query, the defaultValue will be returned
					//		instead.
					var ret = null;
					var xpath = mapping.xpath;
					var type = mapping.type;
					var targetName = mapping.targetName;
					var context = this._feed;
					if(item) {
						this._assertIsItem(item);
						context = item.element;
					}
					if(type == "attr") {
						ret = this._getAttrByXpath(context, xpath, targetName);
					}
					else {
						ret = this._getNodeByXpath(context, xpath, targetName);
					}
					
					if(!ret.found && item && item._backup) {
						// we didn't find any nodes matching the xpath query, and
						// this item has been copied from its original for modification,
						// so perhaps we explicitly removed it in the modified version for
						// performance reasons... so lets look it up in the original unmodified version						
						context = item._backup;
						if(type == "attr") {
							ret = this._getAttrByXpath(context, xpath, targetName);
						}
						else {
							ret = this._getNodeByXpath(context, xpath, targetName);
						}
						
						// if ret.found is still false, then just return the defaultValue
						if (!ret.found && defaultValue) {
							ret.value = defaultValue;
						}
					}
					
					if (type == "attr" && ret.value && ret.value.length === 0) {
						ret.value = null;
					}
					
					return ret.value;
				},
				
				setValueByMapping: function( /* com.ibm.data.AtomEntryItem */ item, 
						/* Object */ mapping, 
						/* Value */ value){
					// summary: Executes the correct query API using the mapping argument to
					//		retrieve the desired attribute value for the item as specified by the 
					// 		mapping.
					// mapping: A mapping object from this object's attrMappings
					// value: The value to set that matches the mapping rule on the item.
					var xpath = mapping.xpath;
					var type = mapping.type;
					var targetName = mapping.targetName;
					var context = this._feed;
					var ret = false;
					if(item) {
						this._assertIsItem(item);
						context = item.element;
					}
					if(type == "attr") {
						ret = this._setAttrByXpath(context, xpath, targetName, value);
					}
					else {
						ret = this._setNodeByXpath(context, xpath, targetName, value);
					}
					
					if(!ret && mapping.setter) {
						return mapping.setter.apply(this, arguments);
					}
					return ret;
				},
				
				setValuesByMapping: function( /* com.ibm.data.AtomEntryItem */ item, 
						/* Object */ mapping, 
						/* Array */ values){
					// summary: Executes the correct query API using the mapping argument to
					//		retrieve the desired attribute value for the item as specified by the 
					// 		mapping.
					// mapping: A mapping object from this object's attrMappings
					// values: The value to set that matches the mapping rule on the item.
					var xpath = mapping.xpath;
					var type = mapping.type;
					var targetName = mapping.targetName;
					var context = this._feed;
					var ret = false;
					if(item) {
						this._assertIsItem(item);
						context = item.element;
					}
					if(type == "attr") {
						ret = this._setAttrsByXpath(context, xpath, targetName, value);
					}
					else {
						ret = this._setNodesByXpath(context, xpath, targetName, value);
					}
					
					if(!ret && mapping.setter) {
						return mapping.setter.apply(this, arguments);
					}					
					return ret;
				},
				
				getAttributes: function(/* com.ibm.data.AtomEntryItem? */ item){
					// summary: Gets the valid attributes for the given item if one is provided and
					//		returns an array of attribute names in String format.  If the item is
					//		null, it returns an array of attributes on the current feed that can
					//		be retrieved via the getFeedValue function.
					// item: Optional argument to get the list of attributes from.
					var attrs = [];
					var x = null;
					if(item) {
						this._assertIsItem(item);
						for(x in item.attrMappings) {
							attrs.push(x);
						}
					}
					else {
						for(x in this.attrMappings) {
							attrs.push(x);
						}
					}
					
					return attrs;
				},
				
				hasAttribute: function(	/* com.ibm.data.AtomEntryItem */ item,
							/* String */ attribute){
					// summary: Returns true if the attribute is a valid attribute on the given item,
					//		false otherwise.  This does not check if the attribute value on the item
					//		is null or empty, but just checks if the item supports that attribute.
					// item: Item to check if the attribute is valid
					// attribute: Name of the attribute to check
					this._assertIsItem(item);
					this._assertIsString(attribute);
					if(attribute.charAt(attribute.length - 1) == '$') {
						// this looks like an attribute whose map rule is parameterizable
						// so lets defer checking if its valid until later so we don't
						// duplicate any string processing
						return true;
					}
					if (item.attrMappings[attribute]) {
						return true;
					}
					else {
						return false;
					}
				},
				
				containsValue: function(/* com.ibm.data.AtomEntryItem */ item,
							/* String */ attribute, 
							/* Object */ value){
					// summary: Returns true if the value of the attribute on the given item is
					//		equal to the value argument, false otherwise.  If the attribute is a
					//		multi-valued attribute, it will check all the values of the attribute.
					// item: Item to check if the attribute is valid
					// attribute: Name of the attribute to check
					// value: Value to compare the actual value(s) to.
					var values = this.getValues(item, attribute);
					for(var i = 0; i < values.length; i++) {
						if (values[i] == value) {
							return true;
						}
					}
					return false;
				},
				
				isItem: function(/* Object */ something){
					// summary: Returns true if the argument is a valid item in this store, false otherwise.
					// something: Object to check to determine if it is an item in this store.
					return something.store == this && something.element && !something._isDeleted;
				},
				
				isItemLoaded: function(/* Object */ something) {
					// summary: All valid items in this data store are loaded all of the time as there
					//		is no support currently for stubs.  Therefore, this is effectively the same
					//		as isItem.
					return this.isItem(something) && something.loaded;
				},
				
				loadItem: function(/* Object */ keywordArgs){
					// summary: All valid items in this data store are loaded all of the time as there
					//		is no support currently for stubs.  Therefore, this function is a no-op. 
				},
				getResultSize: function(/*DOMDoc*/ doc, /*Request*/ request, /*Array*/ items) {
					// summary: Gets the total number of items retrieved by the query, which is not
					//		necessarily the number of items returned to the callbacks to fetch.
					//		This can be used for paging purposes to get the total number of items
					//		on the server that match the query, where subsequent fetch requests can
					//		be made to retrieve additional pages.
					return items.length;
				},
				processFetchedItems: function(/*Array*/ items, /*Request*/ request) {
					// summary: Extension point for descendants or consumers of this store to preprocess
					// 		the list of items that the store returns from a fetch call.  Allows a store
					// 		to filter the list or implement caching techniques on the client, or sort
					// 		the items, or anything else.
					// items: Array items of this data store found in the response of a fetch call
					// returns: Array items of this data store after processing
					return items;
				},		
				processResponse: function(/*DOMDoc*/ xmlDoc, /*Request*/ request) {
					// summary: Extension point for descendants or consumers of this store to handle
					//		responses from server requests for data.  Most subclasses can leave this
					// 		function as-is, but if special handling is required that cannot be done
					// 		with other extension points, this can be overridden as well.
					// 		Must call onBegin, onItem, and onComplete callbacks correctly as 
					// 		specified by dojo.data.api.Read.  The onError callback is handled elsewhere.
					// xmlDoc: DOMDoc of the response from an IO request
					// request: Request used to fetch the result
					if (request.aborted) {
						return;
					}
					var composite = this._parseFeed(request, xmlDoc); 
					var items = composite.items;
					this._feed = composite.root;
					items = this.processFetchedItems(items, request);
					if (request.onBegin) {
						request.onBegin.call(request.scope, this.getResultSize(composite.root, request, items), request);
					}
					if(request.onItem) {
						for(var i = 0; i < items.length; i++) {
							if (request.aborted) {
								return;
							}
							request.onItem.call(request.scope, items[i], request);
						}
					}
					if(request.onComplete) {
						// call onComplete with items array if onItem wasn't specified, otherwise
						// call it with null
						if (request.aborted) {
							return;
						}
						if (!request.onItem) {
							request.onComplete.call(request.scope, items, request);
						}
						else {
							request.onComplete.call(request.scope, null, request);
						}
					}
				},
				fetch: function( keywordArgs ) {
					//    summary:
			        //        Given a query and set of defined options, such as a start and count of items to return,
			        //        this method executes the query and makes the results available as data items.
			        //        The format and expectations of stores is that they operate in a generally asynchronous 
			        //        manner, therefore callbacks are always used to return items located by the fetch parameters.
			        //
			        //    description:
			        //        A Request object will always be returned and is returned immediately.
			        //        The basic request is nothing more than the keyword args passed to fetch and 
			        //        an additional function attached, abort().  The returned request object may then be used 
			        //        to cancel a fetch.  All data items returns are passed through the callbacks defined in the 
			        //        fetch parameters and are not present on the 'request' object.
			        //
			        //        This does not mean that custom stores can not add methods and properties to the request object
			        //        returned, only that the API does not require it.  For more info about the Request API, 
			        //        see dojo.data.api.Request
			        //
			        //    keywordArgs:
			        //        The keywordArgs parameter may either be an instance of 
			        //        conforming to dojo.data.api.Request or may be a simple anonymous object
			        //        that may contain any of the following:
			        //        { 
			        //            query: query-string or query-object,
			        //            queryOptions: object,
			        //            onBegin: Function,
			        //            onItem: Function,
			        //            onComplete: Function,
			        //            onError: Function,
			        //            scope: object,
			        //            start: int
			        //            count: int
			        //            sort: array
			        //        }
			        //        All implementations should accept keywordArgs objects with any of
			        //        the 9 standard properties: query, onBegin, onItem, onComplete, onError 
			        //        scope, sort, start, and count.  Some implementations may accept additional 
			        //        properties in the keywordArgs object as valid parameters, such as 
			        //        {includeOutliers:true}.         
			        //
					//	The *query* parameter.
					//        The query may be optional in some data store implementations.
					//        The dojo.data.api.Read API does not specify the syntax or semantics
					//        of the query itself -- each different data store implementation
					//        may have its own notion of what a query should look like.
					//        However, as of dojo 0.9, 1.0, and 1.1, all the provided datastores in dojo.data
					//        and dojox.data support an object structure query, where the object is a set of 
					//        name/value parameters such as { attrFoo: valueBar, attrFoo1: valueBar1}.  Most of the
					//        dijit widgets, such as ComboBox assume this to be the case when working with a datastore 
					//        when they dynamically update the query.  Therefore, for maximum compatibility with dijit 
					//        widgets the recommended query parameter is a key/value object.  That does not mean that the
					//        the datastore may not take alternative query forms, such as a simple string, a Date, a number, 
					//        or a mix of such.  Ultimately, The dojo.data.api.Read API is agnostic about what the query 
					//        format.  
					//        Further note:  In general for query objects that accept strings as attribute 
					//        value matches, the store should also support basic filtering capability, such as * 
					//        (match any character) and ? (match single character).  An example query that is a query object
					//        would be like: { attrFoo: "value*"}.  Which generally means match all items where they have 
					//        an attribute named attrFoo, with a value that starts with 'value'.
			        //
			        //    The *queryOptions* parameter
			        //        The queryOptions parameter is an optional parameter used to specify optiosn that may modify
			        //        the query in some fashion, such as doing a case insensitive search, or doing a deep search
			        //        where all items in a hierarchical representation of data are scanned instead of just the root 
			        //        items.  It currently defines two options that all datastores should attempt to honor if possible:
			        //        {
			        //            ignoreCase: boolean, //Whether or not the query should match case sensitively or not.  Default behaviour is false.
			        //            deep: boolean     //Whether or not a fetch should do a deep search of items and all child 
			        //                            //items instead of just root-level items in a datastore.  Default is false.
			        //        }
			        //
			        //    The *onBegin* parameter.
			        //        function(size, request);
			        //        If an onBegin callback function is provided, the callback function
			        //        will be called just once, before the first onItem callback is called.
			        //        The onBegin callback function will be passed two arguments, the
			        //        the total number of items identified and the Request object.  If the total number is
			        //        unknown, then size will be -1.  Note that size is not necessarily the size of the 
			        //        collection of items returned from the query, as the request may have specified to return only a 
			        //        subset of the total set of items through the use of the start and count parameters.
			        //
			        //    The *onItem* parameter.
			        //        function(item, request);
			        //        If an onItem callback function is provided, the callback function
			        //        will be called as each item in the result is received. The callback 
			        //        function will be passed two arguments: the item itself, and the
			        //        Request object.
			        //
			        //    The *onComplete* parameter.
			        //        function(items, request);
			        //
			        //        If an onComplete callback function is provided, the callback function
			        //        will be called just once, after the last onItem callback is called.
			        //        Note that if the onItem callback is not present, then onComplete will be passed
			        //        an array containing all items which matched the query and the request object.  
			        //        If the onItem callback is present, then onComplete is called as: 
			        //        onComplete(null, request).
			        //
			        //    The *onError* parameter.
			        //        function(errorData, request); 
			        //        If an onError callback function is provided, the callback function
			        //        will be called if there is any sort of error while attempting to
			        //        execute the query.
			        //        The onError callback function will be passed two arguments:
			        //        an Error object and the Request object.
			        //
			        //    The *scope* parameter.
			        //        If a scope object is provided, all of the callback functions (onItem, 
			        //        onComplete, onError, etc) will be invoked in the context of the scope
			        //        object.  In the body of the callback function, the value of the "this"
			        //        keyword will be the scope object.   If no scope object is provided,
			        //        the callback functions will be called in the context of dojo.global().  
			        //        For example, onItem.call(scope, item, request) vs. 
			        //        onItem.call(dojo.global(), item, request)
			        //
			        //    The *start* parameter.
			        //        If a start parameter is specified, this is a indication to the datastore to 
			        //        only start returning items once the start number of items have been located and
			        //        skipped.  When this parameter is paired withh 'count', the store should be able
			        //        to page across queries with millions of hits by only returning subsets of the 
			        //        hits for each query
			        //
			        //    The *count* parameter.
			        //        If a count parameter is specified, this is a indication to the datastore to 
			        //        only return up to that many items.  This allows a fetch call that may have 
			        //        millions of item matches to be paired down to something reasonable.  
			        //
			        //    The *sort* parameter.
			        //        If a sort parameter is specified, this is a indication to the datastore to 
			        //        sort the items in some manner before returning the items.  The array is an array of 
			        //        javascript objects that must conform to the following format to be applied to the
			        //        fetching of items:
			        //        {
			        //            attribute: attribute || attribute-name-string,
			        //            descending: true|false;   // Optional.  Default is false.
			        //        }
			        //        Note that when comparing attributes, if an item contains no value for the attribute
			        //        (undefined), then it the default ascending sort logic should push it to the bottom 
			        //        of the list.  In the descending order case, it such items should appear at the top of the list.
			        // 
			        //    returns:
			        //        The fetch() method will return a javascript object conforming to the API
			        //        defined in dojo.data.api.Request.  In general, it will be the keywordArgs
			        //        object returned with the required functions in Request.js attached.
			        //        Its general purpose is to provide a convenient way for a caller to abort an
			        //        ongoing fetch.  
			        // 
			        //        The Request object may also have additional properties when it is returned
			        //        such as request.store property, which is a pointer to the datastore object that 
			        //        fetch() is a method of.
			        //
			        //    exceptions:
			        //        Throws an exception if the query is not valid, or if the query
			        //        is required but was not supplied.
					if (!keywordArgs) {
						keywordArgs = {};
					}
			        var me = this;
					keywordArgs.aborted = false;
					if (!keywordArgs.scope) {
						keywordArgs.scope = dojo.global;
					}
					var url = this._buildUrl(keywordArgs, this.url);
					keywordArgs.url = url;
					var loadHandler = function(response, ioArgs) {
						if (keywordArgs.aborted) {
							return;
						}
						if (dojo.isIE) {
							response = com.ibm.domUtilities.docFromString(response);
						}
						me.doc = response;
						me.processResponse(response, keywordArgs);
					};
					var errorHandler = function(error, ioArgs) {
						if (keywordArgs.onError) {
							keywordArgs.onError.call(keywordArgs.scope, error, keywordArgs);
						}
					};
					var preventCache = false;
					if(keywordArgs.queryOptions && keywordArgs.queryOptions.preventCache) {
						preventCache = true; 
					}
					var args = {
						preventCache: preventCache,
						content: {},
						url: url,
						handleAs: "xml"
					}
					if(keywordArgs.queryOptions && keywordArgs.queryOptions.timeout) {
						args.timeout = keywordArgs.queryOptions.timeout;
					}
					else if(this.timeout) {
						args.timeout = this.timeout;
					}
					if(dojo.isIE) {
						args.handleAs = "text";
						args.content["ibm.web2.contentType"] = "text/xml";
					}
					
					var handle = null;
					keywordArgs.abort = function() {
						keywordArgs.aborted = true;
						handle.cancel();
					};
					args = this.modifyRequestArgs(args, keywordArgs);
					
					handle = dojo.xhrGet(args);
					handle.addCallback(loadHandler);
					handle.addErrback(errorHandler);

					this._lastRequest = keywordArgs;
					return keywordArgs;
				},
				modifyRequestArgs: function(ioArgs, request) {
					// summary: Allows modification to request arguments before sending a request
					//		to the server.  Subclasses may override this to modify arguments
					//		like setting headers, manipulating the url, overriding a handleAs argument,
					//		or anything else.  Returns the modified request args.
					// ioArgs: dojo.__XhrArgs request args to be sent to the server
					// request: dojo.data.api.Request object
					// returns: dojo.__XhrArgs modified request arguments
					return ioArgs;
				},
				_queryUrlToObject: function(queryStr) {
					if (!queryStr || queryStr.length === 0) {
						return {};
					}
					var start = queryStr.indexOf("?");
					var str = queryStr;
					if(start > -1 && (start < str.length - 1)) { 
						// extract only the query part of the queryStr URL
						str = queryStr.substring(start + 1);
					}
					return dojo.queryToObject(str);
				},
				_prepareQuery: function(keywordArgs) {
					var query = keywordArgs.query;
					if (!query) {
						keywordArgs.query = {};
					}
					else 
						if (dojo.isString(query)) {
							keywordArgs.query = this._queryUrlToObject(query);
						}
					return this.prepareQuery(keywordArgs);
				},
				prepareQuery: function(keywordArgs) {
					// summary: User overridable function to modify the keywordArgs object
					// 		used to fetch results from the back end after the keywordArgs.query
					//		property has been normalized to an object map but before any other
					//		processing has taken place to build the URL.  This can be used to
					//		extract other parts of the keywordArgs map to add properties to the
					//		query object that are dependent on the back end implementation.  One
					//		example includes extracting the keywordArgs.sort parameters and appending
					//		appropriate properties to the keywordArgs.query property that will end
					//		up being built into the generated URL to the server.
					// returns: Object Modified keywordArgs object.
					return keywordArgs;
				},
				_buildUrl: function(keywordArgs, baseUrl) {
					// summary: Builds a url string from this store's base url and the
					// 		query argument.
					// keywordArgs: Object
					//		A request object map as sent to the fetch function
					// returns: String The constructed url.
					var ret = "";
					var keywordArgs = this._prepareQuery(keywordArgs);
					var queryPart = dojo.objectToQuery(keywordArgs.query);
					if (baseUrl.indexOf("?") > -1) {
						ret = baseUrl + "&" + queryPart; // String
					}
					else {
						ret = baseUrl + "?" + queryPart; // String
					}
					
					return (this.modifyUrl(keywordArgs, ret));
				},
				modifyUrl: function(keywordArgs, url) {
					return url;
				},
				_parseFeed: function(request, xmlDoc) {
					var items = [];
					var root = null;
					var result = this._getNodeByXpath(xmlDoc, "/atom:feed");
					if(!result.found) {
						result = this._getNodeByXpath(xmlDoc, "/atom:entry");
						if(!result.found) {
							// the root is not an atom:feed or atom:entry
							throw new Error("Illegal atom feed format: the root element is not an ATOM feed or entry element.");
						}
						else {
							// the root is an atom:entry element, so there's only one item
							root = result.value;
							var query = this._queryUrlToObject(request.url);
							items.push(this._getItem({element: root, query: query}));
						}
					}
					else {
						// the root is an atom:feed element
						root = result.value;
						var query = this._queryUrlToObject(request.url);
						result = this._getNodesByXpath(root ? root : xmlDoc, "./atom:entry");
						if(result.found) {
							var nodes = result.value;
							for(var i = 0; i < nodes.length; i++) {
								items.push(this._getItem({element: nodes[i], query: query}));
							}
						}
					}
					
					return {items: items, root: root};
				},
				
				getFeatures: function () {
					//	summary:
					//		Return supported data APIs
					//	returns:
					//		Map of supported data APIs with keys as API classes and values as true/false to indicate support
					//		by this store.
					return this._features; //returns Map
				},
				
				close: function(/*dojo.data.api.Request || keywordArgs || null */ request){
					if (request && request.abort) {
						request.abort();
					}
				},
				
				getLabel: function(/* com.ibm.data.AtomEntryItem */ item){
					return this.getEPResolvedValue(item, "title");
				},
				
				getLabelAttributes: function(/* com.ibm.data.AtomEntryItem */ item){
					return ['title'];
				},
				
				/********************************/
				/**                            **/
				/**                            **/
				/**    dojo.data.api.Write     **/
				/**                            **/
				/**                            **/
				/********************************/
				newItem: function(/* Object? */ keywordArgs, /*Object?*/ parentInfo){
					// summary: Must be overridden by stores that extend this but support writes,
					//		like ATOM services that support APP.
					return null;
				},
				
				deleteItem: function(/* com.ibm.data.AtomEntryItem */ item){
					// summary: Deletes an item from the store.  Does not persist to the server until save is called.
					// item: The item to delete.
					// returns: Boolean true if successful, false otherwise.							
					if (!this._deletedItems) {
						this._deletedItems = [];
					}
					item.backup();
					this._deletedItems.push(item);
					// storing identity into item since we need it later and can't access it through store APIs
					// after it's been marked as deleted
					item.id = this.getIdentity(item);
					item._isDeleted = true;
					// we are assuming that order does not matter, so we don't have to save the item's
					// current position in the list of entries in this feed
					return true;
				},
				
				setValue: function(	/* com.ibm.data.AtomEntryItem */ item, 
						/* String */ attribute,
						/* almost anything */ value){
					var ret = false;
					var oldValue = null;
					if(this.hasAttribute(item, attribute)) {
						var mapRule = this.getMapRule(attribute, item.attrMappings);
						// if mapRule is null here, then we didn't find one
						// in the map, so we can't proceed successfully
						if(mapRule) {
							item.backup();
							oldValue = this.getValueByMapping(item, mapRule);
							ret = this.setValueByMapping(item, mapRule, value);
							if(ret) {
								this._addDirtyItem(item);
								item.logWrite({attribute: attribute, value: value});
							}
						}
					}
					else {
						throw new Error(attribute + " is not an attribute of any item in this store");
					}
					return {success: ret, oldValue: oldValue, newValue: value};
				},
				
				setValues: function(/* com.ibm.data.AtomEntryItem */ item,
						/* String */ attribute, 
						/* array */ values){
					var ret = false;
					var oldValue = null;
					if(this.hasAttribute(item, attribute)) {
						var mapRule = this.getMapRule(attribute, item.attrMappings, true);
						// if mapRule is null here, then we didn't find one
						// in the map, so we can't proceed successfully
						if(mapRule) {
							item.backup();
							oldValue = this.getValueByMapping(item, mapRule);
							ret = this.setValuesByMapping(item, mapRule, values);
							if(ret) {
								this._addDirtyItem(item);
								item.logWrite({attribute: attribute, values: values});
							}
						}
					}
					else {
						throw new Error(attribute + " is not an attribute of any item in this store");
					}
					return {success: ret, oldValue: oldValue, newValue: values};
				},
				
				unsetAttribute: function(/* com.ibm.data.AtomEntryItem */ item, 
								/* String */ attribute){
					var ret = false;
					var oldValue = null;
					var value = null;
					if(this.hasAttribute(item, attribute)) {
						var mapRule = this.getMapRule(attribute, item.attrMappings);
						// if mapRule is null here, then we didn't find one
						// in the map, so we can't proceed successfully
						if(mapRule) {
							item.backup();
							oldValue = this.getValueByMapping(item, mapRule);
							if(mapRule.type == "attr") {
								ret = this.setValueByMapping(item, mapRule, "");
								value = "";
							}
							else {
								// it's a node or node property
								if (mapRule.targetName) {
									ret = this.setValueByMapping(item, mapRule, null);
								}
								// if targetName, then it's a property
								else 
									if (oldValue) {
										// if no targetName, then it's a node... so remove the node				
										oldValue.parentNode.removeChild(oldValue);
										ret = true;
									}
							}
							
							if(ret) {
								this._addDirtyItem(item);
								item.logWrite({attribute: attribute, value: value});
							}
						}
					}
					return {success: ret, oldValue: oldValue, newValue: value};
				},
				
				save: function(/* Object */ keywordArgs){
					var it = null;
					for(var d = 0; d < this._deletedItems.length; d++) {
						it = this._deletedItems[d];
						it.persist();
						delete it.element;
					}
					for(var i = 0; i < this._dirtyItems.length; i++) {
						this._dirtyItems[i].persist();
					}
					for(var i = 0; i < this._newItems.length; i++) {
						this._newItems[i].persist();
					}
					
					// the persist operation of the above items set some values on their backups
					// which may have updated the dirtyItems list... by putting this below here
					// we're removing those immediately if they are here 
					
					// instead of just reinitializing these pointers,
					// splice these so that we can keep the same array references forever in case others have
					// pointers to these still (so that they won't break)
					this._newItems.splice(0, this._newItems.length);
					this._dirtyItems.splice(0, this._dirtyItems.length);
					this._deletedItems.splice(0, this._deletedItems.length);
				},
				_addDirtyItem: function(/* com.ibm.portal.data.ContentModelItem */ item) {
					if (item._isDirty) {
						return;
					}
					item._isDirty = true;
					
					// need to check this
					for(var i = 0; i < this._dirtyItems.length; i++) {
						if (this._dirtyItems[i] == item) {
							return;
						}
					}
					
					this._dirtyItems.push(item);
				},
				
				revert: function(){
					var it = null;
					for(var d = 0; d < this._deletedItems.length; d++) {
						it = this._deletedItems[d];
						it.restore();
						delete item._isDeleted;
					}
					for(var i = 0; i < this._dirtyItems.length; i++) {
						this._dirtyItems[i].restore();
					}
					this._dirtyItems = [];
					this._deletedItems = [];
				},
				
				isDirty: function(/* com.ibm.data.AtomEntryItem? */ item){
					// summary: Determines whether or not an item is dirty or if this store in general has dirty items.
					//		If item is specified, it returns true if that item is dirty, and false otherwise.
					//		If no item is specified, it returns an array of all the dirty items in this store (modified,
					//		deleted, and new), and false if there are none.
					// item: Optional argument to check if a particular item is dirty.  Leaving this null
					if (item && this._assertIsItem(item)) {
						return item._isDirty;
					}
					else {
						var array = this._dirtyItems.concat(this._deletedItems).concat(this._newItems);
						if (!array || array.length === 0) {
							return false;
						}
						else {
							return array;
						}
					}
				}
			}
);	


dojo.declare( "com.ibm.data.AtomEntryItem",
			com.ibm.data.XpathHelper, 
			{
				namespaces: dojo.mixin({}, com.ibm.data.AtomFeedStore.prototype.namespaces),
		        // attrMappings: This maps attribute names to a query object consisting of an 
		        // 		xpath expression used to find the relevant node(s), an attr name, and a type.
		        // 		The map contains key-value pairs in this format:
		        //		{
		        //			attributeName: {xpath: "./this/is/the/xpath/expr", targetName: "attrName"|null, type: "node"|"attr"}  
		        //		}
		        //		The xpath expression is resolved from the context of the atom:entry node 
		        // 		assigned to this atom feed entry item.  The attr property is an optional property
		        //		used to specify whether to get an object property of the returned DOM node object or 
		        // 		an attribute of the returned DOM node.  The type specifies what type the lookup
		        //		will perform in conjunction with the attr.  If the lookup is an attribute of the
		        // 		DOM node, it will attempt to resolve any namespacing it encounters when looking
		        // 		up the attribute.  The following explains the possible combinations of lookup 
		        // 		mechanisms.
		        // 		
		        // 		xpath: "./node", targetName: "textContent", type: "node" = node["textContent"]
		        //		xpath: "./node", targetName: "href", type: "attr" = node.getAttribute("href")
		        // 		xpath: "./node", targetName: "textContent", type: "node" = cross browser node["textContent"] property
		        // 		xpath: "./node", targetName: null, type: "node" = node
		        //  	xpath: "./node", targetName: null, type: "attr" = invalid query, requires the attribute name
		        //
		        //		Map rules can be parameterized by substituting parameters specified by the caller into the
		        //		rule template.  Parameterized map rules MUST end with a $ character to mark them as such.
		        // 		Example:
		        //	 		pAttribute$: {xpath: "./${0}['${1}']", targetName: "${2}", type: "node", customRuleProperty: "${1}"}
		        //
		        //		Callers supply a comma-separated list of parameter values to be bound to subsequent numerical
		        //		parameter keys in the template respectively surrounded by brackets immediately following the
		        //		name of the attribute key but before the $ character.
		        //		Example:
		        // 			To request the value of pAttribute$ with values set for the parameters, the caller would 
		        // 			use code like this -
		        //		store.getValue(item, "pAttribute[div, id, nodeValue]$");
		        //
		        attrMappings: dojo.mixin({}, com.ibm.data.AtomFeedStore.prototype.attrMappings, { 		
					subtitle: {xpath: "./atom:subtitle", targetName: "textContent", type: "node", setter: 
						function(item, rule, value){
							var elem = this._createNSElement(item.element.ownerDocument, "atom:subtitle");
							this._setNodeProp(elem, rule.targetName, value);
							item.element.appendChild(elem);
							return true;
						}
					},
					generator: {xpath: "./atom:generator", targetName: "textContent", type: "node", setter: 
						function(item, rule, value){
							var elem = this._createNSElement(item.element.ownerDocument, "atom:generator");
							this._setNodeProp(elem, rule.targetName, value);
							item.element.appendChild(elem);
							return true;
						}
					},
					icon: {xpath: "./atom:icon", targetName: "textContent", type: "node", setter: 
						function(item, rule, value){
							var elem = this._createNSElement(item.element.ownerDocument, "atom:icon");
							this._setNodeProp(elem, rule.targetName, value);
							item.element.appendChild(elem);
							return true;
						}
					},
					logo: {xpath: "./atom:logo", targetName: "textContent", type: "node", setter: 
						function(item, rule, value){
							var elem = this._createNSElement(item.element.ownerDocument, "atom:logo");
							this._setNodeProp(elem, rule.targetName, value);
							item.element.appendChild(elem);
							return true;
						}
					}
				}), 
				
				constructor: function( /*Map*/ args ) {
					dojo.mixin(this, args);
					this._writeLog = [];
				},
				toString: function() {
					return "<" + this.__getClassName() + ">";
				},
				_onCreate: function() {
					// summary: Called internally to indicate an item has been created.  Should
					//		be called immediately on creation for stores that do not save to
					//		a backend server, but should be called on a valid server response for
					// 		an item that was created and saved to the server successfully.  This
					// 		calls onCreate to notify listeners of the event and can therefore be
					// 		overriden if custom logic needs to be applied to handle cases where
					// 		other conditions need to be satisfied before the onCreate event is called.
					this.onCreate();
				},
				onCreate: function() {
					// summary: Called when this item is created.  This callback is reserved
					// 		for sending notifications when a new item stub has been created
					// 		on the actual server.  This will be called when a new item has been
					//		created, saved to the server, and the server responds back with
					//		a verification of the created item.  Some stores may not have any
					// 		notion of creating items on the server and should call this immediately
					// 		when the item is created on the client, while others actually defer 
					// 		the full creation of a new item from the newItem call until after the 
					// 		save operation has persisted to the backend.  This allows interested 
					// 		parties to get notified when an item they've created is actually saved
					// 		on the server.  This is especially useful if the server has to generate
					//		something like a unique ID for the item which is not available on the
					//		item until the server response comes back.
				},
				_makeModifiable: function() {
					// summary: Modifies the element of this item to become modifiable
					//		for writing back to the server.  Subclasses can override this
					//		to do things like prune an item to only include necessary information
					//		for updates and nothing more.  This is called by backup once after
					//		backing up the original element first.  After this returns,
					//		this item's element may have been modified.  Any queries against
					//		this item should now include logic to check the backup copy as well
					//		if a query doesn't return anything as it could have been deleted by
					//		this function.  Care should be taken to ensure that the query result
					//		specifically detects if nothing was found or if the actual value was
					//		null or empty.
				},
				backup: function() {
					// summary: Creates a single backup copy of this item on the client for
					//		later restoration if necessary.  Calling this function multiple
					//		times before restore() or persist() is called on this item will do nothing
					//		after the initial backup, effectively maintaining only the first
					//		version of the item before any changes were made.
					if(!this._backup) {
						this._backup = this.element.cloneNode(true);
						this._makeModifiable();
						this._logEnabled = true;
						return true;
					}
					return false;
				},
				restore: function() {
					// summary: Restores the single backup copy of this item on the client,
					//		erasing all modifications made since backup() was called.
					if(!this._backup) {
						dojo.place(this._backup, this.element, "before");
						this.element.parentNode.removeChild(this.element);
						delete this.element;
						this.element = this._backup;
						this.backup = null;
						this._writeLog.splice(0, this._writeLog.length);
						return true;
					}
					return false;
				},
				persist: function() {
					// summary: Persists the changes made to this item since the backup() was
					// 		called.  After this is called, there is no way to restore the backup
					//		as it is erased completely.
					this._writeLogToBackup();
					this._isDirty = false;
					delete this._backup;
				},
				logWrite: function(map) {
					// summary: Logs write operations to this item so that they can later
					//		be repeated to the backup during persistence.
					if (this._logEnabled) {
						this._writeLog.push(map);
					}
				},
				_writeLogToBackup: function() {
					// summary: Repeates the write log for this item to the original backup
					// 		node.  Used mainly for persisting changes to support a 2-phase
					//		write operation (write, commit).
					if(this._backup) {
						this.element = this._backup;
						this._logEnabled = false;
						for(var i = 0; i < this._writeLog.length; i++) {
							var op = this._writeLog[i];
							if(op.values) {
								this.store.setValues(this, op.attribute, op.values);
							}
							else {
								this.store.setValue(this, op.attribute, op.value);
							}
						}
						this._writeLog.splice(0, this._writeLog.length);
					}
				}
			}
);


dojo.declare( "com.ibm.data.AtomPersonConstruct",
			com.ibm.data._XmlConstruct,
			{
				// summary: Construct for retrieving appropriate information
				// 		from an Atom Person Construct as defined in 
				// 		http://tools.ietf.org/html/rfc4287#section-3.2.
				
				namespaces: dojo.mixin({}, com.ibm.data.AtomFeedStore.prototype.namespaces),
		        
				constructor: function(/*DOMNode*/ root) {
					this.root = root;
				},
				getName: function() {
					// summary: Gets the name specified by this Atom person construct.
					// returns: String
					var result = this._getNodeByXpath(this.root, "./atom:name", "textContent");
					if (!result.found) {
						result.value = "";
					}
					return result.value;
				},
				getEmail: function() {
					// summary: Gets the email specified by this Atom person construct.
					// returns: String
					var result = this._getNodeByXpath(this.root, "./atom:email", "textContent");
					if (!result.found) {
						result.value = "";
					}
					return result.value;
				},
				getURI: function() {
					// summary: Gets the name specified by this Atom person construct.
					// returns: String
					var result = this._getNodeByXpath(this.root, "./atom:uri", "textContent");
					if (!result.found) {
						result.value = "";
					}
					return result.value;
				},
				toString: function() {
					// summary: Gets the name string specified by this Atom person construct.
					// returns: String
					return this.getName();
				}
			}
);

dojo.declare( "com.ibm.data.AtomDateConstruct",
			com.ibm.data._XmlConstruct,
			{
				// summary: Construct for retrieving javascript-appropriate information
				// 		from an Atom Date Construct as defined in 
				// 		http://tools.ietf.org/html/rfc4287#section-3.3.
				
				namespaces: dojo.mixin({}, com.ibm.data.AtomFeedStore.prototype.namespaces),
		        
				// Supports date strings in the following formats - 
				//		2003-12-13T18:30:02Z
				//		2003-12-13T18:30:02.25Z
				//		2003-12-13T18:30:02+01:00
				//		2003-12-13T18:30:02.25+01:00
				
				constructor: function(/*DOMNode*/ root) {
					this.root = root;
				},
				getDate: function() {
					// summary: Parses and retrieves a javascript Date object from a date string
					//		specified in an Atom feed according to the allowable string formats
					//		by the Atom spec itself (http://tools.ietf.org/html/rfc4287#section-3.3)
					// returns: Date
					if (this.date) {
						return this.date;
					}
					
					var d = this._getNodeProp(this.root, "textContent");
					if (!d) {
						return null;
					}
					
					this.date = dojo.date.stamp.fromISOString(d);
					return this.date;
				},
				getTime: function() {
					// summary: Gets the time specified by this Atom date construct.
					// returns: int
					this.getDate();
					if (this.date) {
						return this.date.getTime();
					}
					
					return null;
				},
				toString: function() {
					// summary: Gets a string representation of the date specified by this
					//		Atom data construct.
					this.getDate();
					if (this.date) {
						return this.date.toString();
					}
					return "";
				}
			}
);

}
