if(!dojo._hasResource["com.ibm.mm.builder.iwidget.ModeSelector"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.iwidget.ModeSelector"] = true;
dojo.provide("com.ibm.mm.builder.iwidget.ModeSelector");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit._Container");
dojo.require("dijit.Dialog");

dojo.require("com.ibm.mm.catalog.hubUtil");
dojo.require("com.ibm.mm.builder.widget.ShadowMenu");

dojo.declare("com.ibm.mm.builder.iwidget.ModeSelector",
	[dijit._Widget, dijit._Templated, dijit._Container],{

	templateString: "<div>"+
					"<div dojoAttachPoint='modeSelectorOuterContainer' class='modeSelector_outerContainer'>" +
						"<div dojoAttachPoint='modeTitle' class='modeSelector_modeTitleDiv' tabindex='0' role='button' wairole='button'>" +
								"<div dojoAttachPoint='modeTitleText' class='modeSelector_modeTitleText'></div>" +
						"</div>" +
						"<div class='modeSelector_modeImage' tabindex='0' dojoAttachPoint='modeSelector_button' role='button' wairole='button' title='Open Mode Selector Menu' aria-label='Open Mode Selector Menu' dojoAttachEvent='onkeypress:_onMenuKeyPress'>" +
								"<img dojoAttachPoint='modeSelector_modeImage_img' alt='Mode Selector button' class='modeSelector_modeImage_img' title=''/>" +
						"</div>" +
					"</div>" +
					"<div dojoAttachPoint='modeSelectorGotoHub' class='modeSelector_iconForHub' >"+
						"<a dojoAttachEvent='onclick:gotoCatalog,onkeypress:_gotoCatalog' role='button' wairole='button' class='modeSelectorLink' dojoattachpoint='gotoHubLink' href='javascript:void(0)' title='Open Catalog in a New Browser' aria-label='Open Catalog in a New Browser'>Open Catalog in a New Browser</a>"+
					"</div>"+
					"</div>",
					
		
	selections: null,
	
	optionTexts:null,
	
	ViewText: null,
	EditText: null,
	SourceText: null,
	CatalogText: null,
	MorePagesText:null,
	
	quickAction: "",
	
	modeSelectorContext:null,
	
	currentPageMode: "View",

	dropDownMenu:null,
	
	userAccessLevel: null,
	
	menuInitialized: false,

	eventService: com.ibm.mashups.services.ServiceManager.getService("eventService"),
		
	constructor:function(prop,node,_iContext){
		this.modeSelectorContext=_iContext;
		if (com.ibm.mm.builder.utils.userUtil.isLockedDownAnonymousMode()) {
			return;
		}
		// set the default mode
		this.selections = {};
		this.selections.ViewMode = "View";
		this.selections.EditMode = "Edit";
		this.selections.SourceMode = "Source";
		this.selections.WidgetMode = "Widget";
		this.selections.CatalogMode = "Catalog";
		this.selections.MorePagesMode = "MorePages";
		
		// init the UI text, replace with message key when do g18n
		this.ViewText = com.ibm.mm.builder.coreWidgetsStrings.I_MODE_SELECTOR_GO_VIEW;
		this.EditText = com.ibm.mm.builder.coreWidgetsStrings.I_MODE_SELECTOR_GO_EDIT;
		this.CatalogText = com.ibm.mm.builder.coreWidgetsStrings.I_MODE_SELECTOR_GO_CATALOG;
		this.CatalogNewWindowText = com.ibm.mm.builder.coreWidgetsStrings.I_MODE_SELECTOR_GO_CATALOG_NEW_WINDOW;
		this.WidgetCreateText = com.ibm.mm.builder.coreWidgetsStrings.I_CREATE_NEW_WIDGET;
		this.FeedCreationText = com.ibm.mm.builder.coreWidgetsStrings.I_MODE_SELECTOR_CREATE_FEED;
		this.FeedMashupCreationText = com.ibm.mm.builder.coreWidgetsStrings.I_MODE_SELECTOR_CREATE_FEEDMASHUP;
		this.SourceText = com.ibm.mm.builder.coreWidgetsStrings.I_MODE_SELECTOR_GO_SOURCE;
		this.MorePagesText = com.ibm.mm.builder.coreWidgetsStrings.I_MODE_SELECTOR_GO_SHARE;
		
		
		this.optionTexts = {};
		this.optionTexts[this.selections.ViewMode] = this.ViewText;
		this.optionTexts[this.selections.EditMode] = this.EditText;
		this.optionTexts[this.selections.SourceMode] = this.SourceText;
		this.optionTexts[this.selections.CatalogMode] = this.CatalogText;
		this.optionTexts[this.selections.MorePagesMode] = this.MorePagesText;
		
		this.quickActionTexts = {};
		this.quickActionTexts[this.selections.ViewMode] = this.ViewText;
		this.quickActionTexts[this.selections.EditMode] = this.EditText;
		
		this.event = [];
		
		this.init = function(){
			this.modeTitleText.title = this.EditText;
			dojo.attr(this.modeTitle,'title',this.EditText);
			dojo.attr(this.modeTitle,'aria-label',this.EditText);			
			this.modeTitleText.innerHTML = this.quickActionTexts[this.selections.ViewMode];
			var wView = dojo.coords(this.modeTitleText).w;
			this.modeTitleText.innerHTML = this.quickActionTexts[this.selections.EditMode];
			var wEdit = dojo.coords(this.modeTitleText).w;
			var width = wView > wEdit ? wView : wEdit;
			this.modeTitleText.style.width = width + "px";
		};
		
		var self = this;
		this.onView = function(){
			dojo.publish("com.ibm.mm.catalog.Topics.Mode_Change", [self.selections.ViewMode]);
			
			if (self.currentPageMode == self.selections.EditMode) {
				// save page
				com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.savePage");
				//TODO  need to add wire here
				dojo.publish(com.ibm.mm.builder.eventTopics.Save_Icon_Change, [false]);
				
				com.ibm.mm.builder.commonActions.changePageMode("view");
				self.updateModeSelector(self.selections.ViewMode);
			}
		};
		
		this.onEdit = function(){
			dojo.publish("com.ibm.mm.catalog.Topics.Mode_Change", [self.selections.EditMode]);
			if (self.currentPageMode == self.selections.ViewMode) {
				com.ibm.mm.builder.commonActions.changePageMode("edit");
				self.updateModeSelector(self.selections.EditMode);
			}
		};
	},
	
	_gotoCatalog:function(e){
		switch(e.keyCode || e.charCode){
			case dojo.keys.ENTER:
			case dojo.keys.SPACE:
			 this.gotoCatalog();
			break;
		}
	},
	
	gotoCatalog:function(){
		com.ibm.mm.builder.commonActions.catalogNewWindow();
	},
	
	initMenu:function(){
		if (this.menuInitialized) {
			return;
		}
		var mycontextmenu = com.ibm.mashups.builder.model.Factory.getContextMenuModel();
		var currentPageId = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().getID();
		var widgetMenus = mycontextmenu.getContextMenu("ContextMenu.action",currentPageId,null,{context:this});
		
		var modeNode = null;
		for (var i = 0; i < widgetMenus.length; ++i) {
			if(widgetMenus[i].isSeparator){
				this.dropDownMenu.addChild(new com.ibm.mm.builder.iwidget.ModeSelectorMenuSeparator());
				continue;
			}
			var mitem = new com.ibm.mm.builder.iwidget.ModeSelectorMenuItem({
					label: widgetMenus[i].title,
					mode: widgetMenus[i].id,
					iconClass: widgetMenus[i].iconClass,
					disabled:!widgetMenus[i].enabled,
					onClick: widgetMenus[i].actionCallBackFunction
					});	

			if (widgetMenus[i].id == this.currentPageMode) {
				modeNode = mitem;
			}
			this.dropDownMenu.addChild(mitem);
			this.dropDownMenu.entrys.push(mitem);
		}
		this.dropDownMenu.startup();
		this.dropDownMenu.setCurrentMode(modeNode.domNode);
		this.menuInitialized = true;
		this.updatePermissionWithLevel();
	},
	
	createMenu : function(){
		var self = this;	
		var tMenu = new com.ibm.mm.builder.iwidget.ModeSelectorMenu({
				targetNodeIds:[this.modeSelector_modeImage_img],
				leftClickToOpen:true,
				openPosition:"BR",
				prepareData: function(){
					self.initMenu();
				}
			});	
		return tMenu;			
	},
		
	postCreate: function() {
		dojo.attr(this.modeSelector_button,"title",com.ibm.mm.builder.coreWidgetsStrings.I_MODE_SELECTOR_OPEN);
		dojo.attr(this.modeSelector_button,"aria-label",com.ibm.mm.builder.coreWidgetsStrings.I_MODE_SELECTOR_OPEN);
		dojo.attr(this.modeSelector_modeImage_img,"alt",com.ibm.mm.builder.coreWidgetsStrings.I_MODE_SELECTOR_BUTTON);
		var isBidi = builderConfig.isBidi;
		if (com.ibm.mm.builder.utils.userUtil.isLockedDownAnonymousMode()) {
			this.modeSelectorOuterContainer.style.display = "none";
			if (!builderConfig.hasHub) {
				this.modeSelectorGotoHub.style.display = "none";
			}
			else {
				this.gotoHubLink.innerHTML = com.ibm.mm.builder.coreWidgetsStrings.I_MODE_SELECTOR_GO_CATALOG_NEW_WINDOW;
				this.gotoHubLink.title = com.ibm.mm.builder.coreWidgetsStrings.I_MODE_SELECTOR_GO_CATALOG_NEW_WINDOW;
			}
			
		}
		else {
			this.modeSelectorGotoHub.style.display = "none";
			imageDom = this.modeSelector_modeImage_img;
			imageDom.src = builderConfig.builderPath + "/images/mode_selector_btn_os.png";
			this.dropDownMenu = this.dropDownMenu || this.createMenu();
			this.init();
			// set the id for automation test 
			this.modeTitle.id = "modeSelector_modetitle_div";
		}
	},
	
	updatePermissionWithLevel:function(accessLevel) {
		if(accessLevel == com.ibm.mm.builder.utils.acModelUtil.VIEW){
			this.userAccessLevel = com.ibm.mm.builder.utils.acModelUtil.VIEW;
		}else{
			this.userAccessLevel = accessLevel ? accessLevel : this.userAccessLevel;
		}
		switch (this.userAccessLevel) {
			case com.ibm.mm.builder.utils.acModelUtil.VIEW:
				if (this.events) {
					dojo.forEach(this.events, dojo.disconnect);
				}
				dojo.addClass(this.modeTitleText, "disabled");
				this.modeTitle.style.cursor = "default";
				break;
				
			case com.ibm.mm.builder.utils.acModelUtil.EDIT:
				if (this.events) {
					dojo.forEach(this.events, dojo.disconnect);
				}
				dojo.removeClass(this.modeTitleText, "disabled");
				this.modeTitle.style.cursor = "pointer";
				this.events = [dojo.connect(this.modeTitle, "onclick", this, "onTitleClick"), dojo.connect(this.modeTitle, "onkeypress", this, "onKeyPress")];
				break;
				
			default:
				dojo.addClass(this.modeTitleText, "disabled");
				this.modeTitle.style.cursor = "default";
				break;
		}
		if (this.menuInitialized) {
			var viewMode = null;
			var editMode = null;
			var self = this;
			dojo.forEach(this.dropDownMenu.entrys, function(item){
				if (self.selections.ViewMode == item.mode) {
					viewMode = item;
				}
				if (self.selections.EditMode == item.mode) {
					editMode = item;
				}
			});
			switch (this.userAccessLevel) {
				case com.ibm.mm.builder.utils.acModelUtil.VIEW:
					/*case com.ibm.mm.builder.utils.acModelUtil.PERSONALIZE:*/
					viewMode.attr('disabled', true);
					editMode.attr('disabled', true);
					break;
					
				case com.ibm.mm.builder.utils.acModelUtil.EDIT:
					viewMode.attr('disabled', false);
					editMode.attr('disabled', false);
					break;
					
				default:
					viewMode.attr('disabled', true);
					editMode.attr('disabled', true);
					break;
			}
		}
	},
	
	onKeyPress: function(evt){
		if(evt && evt.type === "keypress" && (evt.keyCode == dojo.keys.ENTER || evt.charCode == dojo.keys.SPACE)){
			this.onTitleClick();
		}
	},
	
	_onMenuKeyPress:function(evt){
		if(evt && evt.type === "keypress" && (evt.keyCode == dojo.keys.ENTER || evt.charCode == dojo.keys.SPACE)){
			this.dropDownMenu._openMyself(evt);
		}
	},
	
	onTitleClick: function() {
		switch (this.quickAction) {
			case this.selections.ViewMode:
				this.onView();
				break;
			
			case this.selections.EditMode:
				this.onEdit();
				break;
	
			default:
				break;
		}
	},	
	
	_changeQuickAction: function(action) {
		this.quickAction = action;
		this.modeTitleText.innerHTML = this.quickActionTexts[this.quickAction];
		var title = this.optionTexts[this.quickAction];
		this.modeTitleText.title = title;
		dojo.attr(this.modeTitle,'title',title);
		dojo.attr(this.modeTitle,'aria-label',title);
		
		//this._setActionsStyle();
	},
	
	/**
	 * this method will be triggered when the page mode is changed.
	 * mode = "edit" page is in edit mode
	 * mode = "view" page is in view mode
	 * @param {String} mode
	 */
	updateModeSelector: function(mode){
		this.currentPageMode = mode;
		if (mode == this.selections.EditMode){
			this._changeQuickAction(this.selections.ViewMode);
			dojo.publish("com.ibm.mm.catalog.Topics.Mode_Change", [this.selections.EditMode]);
		}
		if (mode == this.selections.ViewMode){
			this._changeQuickAction(this.selections.EditMode);
			dojo.publish("com.ibm.mm.catalog.Topics.Mode_Change", [this.selections.ViewMode]);			
		}
		
	}
});


dojo.declare("com.ibm.mm.builder.iwidget.ModeSelectorMenu",
	[com.ibm.mm.builder.widget.ShadowMenu],{
	
	postCreate: function(){
		this.inherited(arguments);
		this.entrys = [];		
		dojo.addClass(this.domNode, "modeSelectorMenu");
		dojo.subscribe("com.ibm.mm.catalog.Topics.Mode_Change",this,"changeSelected");
	},
	
	changeSelected: function(mode){
		var self = this;
		dojo.forEach(this.entrys,function(item){
			if(mode === item.mode){
				self.setCurrentMode(item.domNode);
			}
		});
	},
	
	setCurrentMode : function(modeDom) {
		var describedNode = null;
		if (this._currentMode) {
			if(this._currentMode == modeDom){
				return;
			}
			var iconNode = dojo.query("td",this._currentMode)[0];
			dojo.removeClass(iconNode, "checked");
			var containerNode = dojo.query("td",this._currentMode)[1];
			dojo.removeClass(containerNode, "checked");
			describedNode = dojo.query("span",containerNode)[0];
			describedNode.innerHTML = "";				
		}
		var td0Dom = dojo.query("td",modeDom)[0];
		dojo.addClass(td0Dom, "checked");
		var td1Dom = dojo.query("td",modeDom)[1];
		dojo.addClass(td1Dom, "checked");
		describedNode = dojo.query("span",td1Dom)[0];		
		describedNode.innerHTML =  " " +com.ibm.mm.builder.coreWidgetsStrings.I_MODE_IS_SELECT;		
		this._currentMode = modeDom;
	},
	
	onClose: function(){
		this.inherited(arguments);
		if(this.targetNodeIds && this.targetNodeIds[0]){
			this.targetNodeIds[0].src = builderConfig.builderPath + "/images/mode_selector_btn_os.png";
		}
	}
});

dojo.declare(
	"com.ibm.mm.builder.iwidget.ModeSelectorMenuItem",
	[dijit.MenuItem],
{
	iconSrc: builderConfig.builderPath + "/images/blueCheckmark.gif", 
	mode:"",
	postCreate: function(){
		this.inherited("postCreate",arguments);	
		this.iconNode.src = this.iconSrc;
		this.domNode.setAttribute("mode", this.mode); 
		dojo.addClass(this.iconNode.parentNode,"menuItemCheckMark");	
		var dijitMenuLabelA11y = dojo.doc.createElement("span");
		dojo.addClass(dijitMenuLabelA11y,"access");
		this.containerNode.appendChild(dijitMenuLabelA11y);		
	},
	//rewrite to only change containerNode to disabled 
	_setDisabledAttr: function(/*Boolean*/ value){
		// summary:
		//		Hook for attr('disabled', ...) to work
		//		Enable or disable this menu item.
		this.disabled = value;
		dojo[value ? "addClass" : "removeClass"](this.containerNode, 'dijitMenuItemDisabled');
		dijit.setWaiState(this.focusNode, 'disabled', value ? 'true' : 'false');
	},
	
	focus: function(){
		this.menuItemCheckMark = dojo.query(".menuItemCheckMark",this.domNode)[0];
		this.menuItemCheckMark.style.backgroundImage = "none";
		this.inherited(arguments);
	},
	
	_setSelected: function(selected){
		this.inherited(arguments);
		if(selected){ return; }
		this.menuItemCheckMark.style.backgroundImage = "url("+builderConfig.builderPath+"/images/sideBar.gif)";
	}

	
});

dojo.declare(
	"com.ibm.mm.builder.iwidget.ModeSelectorMenuSeparator",
	[dijit.MenuSeparator],
{
	templateString: '<tr class="dijitMenuSeparator"><td colspan=4>' +
			'<div class="modeSelector_seperator">' + 
			'<div class="menuItem"> </div>' +
			'<div class="modeSelector_divider""></div>' +
			'</div>' +
			'</td></tr>',
	
	
	destroy: function(){
		dijit.registry.remove(this.domNode.id);
	},
	
	postCreate: function(){
		dojo.setSelectable(this.domNode, false);
		this.domNode.style.height = "2px";
		this.domNode.style.lineHeight = "2px";			
		this.domNode.style.fontSize = "1pt";
	}	
});

}
