if(!dojo._hasResource["com.ibm.mm.builder.utils.htmlUtil"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.utils.htmlUtil"] = true;
dojo.provide("com.ibm.mm.builder.utils.htmlUtil");

dojo.require("com.ibm.mm.builder.constant");

com.ibm.mm.builder.utils.htmlUtil.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger("com.ibm.mm.builder.utils.htmlUtil");

//OpenSocial support change
if (this.widgetType !== null && this.widgetType=="mm_OSGadget"){
	com.ibm.mm.builder.utils.htmlUtil.widgetClass = new RegExp("\\b"+com.ibm.mm.builder.constant.mmGGadget+"\\b");
} else {
	com.ibm.mm.builder.utils.htmlUtil.widgetClass = new RegExp("\\b"+com.ibm.mm.builder.constant.mmIWidget+"\\b");
}
	
com.ibm.mm.builder.utils.htmlUtil.classMatchType = {
	ContainsAll : 0, // all of the classes are part of the node's class (default)
	ContainsAny : 1, // any of the classes are part of the node's class
	IsOnly : 2 // only all of the classes are part of the node's class
};

com.ibm.mm.builder.utils.htmlUtil.endsWith = function(/*string*/str, /*string*/end, /*boolean*/ignoreCase){
// summary:
//	Returns true if 'str' ends with 'end'

	if(ignoreCase){
		str = str.toLowerCase();
		end = end.toLowerCase();
	}
	if((str.length - end.length) < 0){
		return false; // boolean
	}
	return str.lastIndexOf(end) == str.length - end.length; // boolean
};

com.ibm.mm.builder.utils.htmlUtil.startsWith = function(/*string*/str, /*string*/start, /*boolean*/ignoreCase){
	// summary:
	//	Returns true if 'str' starts with 'start'
	if(ignoreCase) {
		str = str.toLowerCase();
		start = start.toLowerCase();
	}
	return str.indexOf(start) === 0; // boolean
};

com.ibm.mm.builder.utils.htmlUtil.getAttribute = function(/* HTMLElement */node, /* string */attr){

	node = dojo.byId(node);

	if((!node)||(!node.getAttribute)){
		// if(attr !== 'nwType'){
		//	alert("getAttr of '" + attr + "' with bad node"); 
		// }
		return null;
	}
	var ta = typeof attr == 'string' ? attr : new String(attr); // JSLINT-IGNORE: 

	// first try the approach most likely to succeed
	var v = node.getAttribute(ta.toUpperCase());
	if((v)&&(typeof v == 'string')&&(v!="")){ 
		return v;	//	string 
	}

	// try returning the attributes value, if we couldn't get it as a string
	if(v && v.value){ 
		return v.value;	//	string 
	}

	// this should work on Opera 7, but it's a little on the crashy side
	if((node.getAttributeNode)&&(node.getAttributeNode(ta))){
		return (node.getAttributeNode(ta)).value;	//	string
	}else if(node.getAttribute(ta)){
		return node.getAttribute(ta);	//	string
	}else if(node.getAttribute(ta.toLowerCase())){
		return node.getAttribute(ta.toLowerCase());	//	string
	}
	return null;	//	string
};

com.ibm.mm.builder.utils.htmlUtil.getParentByType = function(/* HTMLElement */node, /* string */type) {
	//	summary
	//	Returns the first ancestor of node with tagName type.

	var _document = dojo.doc;
	var parent = dojo.byId(node);
	type = type.toLowerCase();
	while((parent)&&(parent.nodeName.toLowerCase()!=type)){
		if(parent==(_document.body||_document.documentElement)){
			return null;
		}
		parent = parent.parentNode;
	}
	return parent;	//	HTMLElement
};

com.ibm.mm.builder.utils.htmlUtil.hasAttribute = function(/* HTMLElement */node, /* string */attr){
	//	summary
	//	Determines whether or not the specified node carries a value for the attribute in question.
	return com.ibm.mm.builder.utils.htmlUtil.getAttribute(dojo.byId(node), attr) ? true : false;	//	boolean
};

com.ibm.mm.builder.utils.htmlUtil.hasClass = function(/* HTMLElement */node, /* string */classname){
	return (new RegExp('(^|\\s+)'+classname+'(\\s+|$)')).test(com.ibm.mm.builder.utils.htmlUtil.getClass(node));	//	boolean
};

com.ibm.mm.builder.utils.htmlUtil.addClass = function(/* HTMLElement */node, /* string */classStr){
	//	summary
	//	Adds the specified class to the end of the class list on the
	//	passed &node;. Returns &true; or &false; indicating success or failure.
	if (com.ibm.mm.builder.utils.htmlUtil.hasClass(node, classStr)) {
	  return false;
	}
	classStr = (com.ibm.mm.builder.utils.htmlUtil.getClass(node) + " " + classStr).replace(/^\s+|\s+$/g,"");
	return com.ibm.mm.builder.utils.htmlUtil.setClass(node, classStr);	//	boolean
};

com.ibm.mm.builder.utils.htmlUtil.setClass = function(/* HTMLElement */node, /* string */classStr){
	//	summary
	//	Clobbers the existing list of classes for the node, replacing it with
	//	the list given in the 2nd argument. Returns true or false
	//	indicating success or failure.
	node = dojo.byId(node);
	var cs = new String(classStr); // JSLINT-IGNORE: 
	try{
		if(typeof node.className == "string"){
			node.className = cs;
		}else if(node.setAttribute){
			node.setAttribute("class", classStr);
			node.className = cs;
		}else{
			return false;
		}
	}catch(e){
		com.ibm.mm.builder.utils.htmlUtil.LOGGER.severe("setClass",dojo.string.substitute(com.ibm.mm.builder.coreWidgetsMessages.E_HTML_UTIL_SET_CLASS_1,[e.message]));
	}
	return true;
};

com.ibm.mm.builder.utils.htmlUtil.getClass = function(/* HTMLElement */node){
	//	summary
	//	Returns the string value of the list of CSS classes currently assigned directly 
	//	to the node in question. Returns an empty string if no class attribute is found;
	node = dojo.byId(node);
	if(!node){ return ""; }
	var cs = "";
	if(node.className){
		cs = node.className;
	}else if(com.ibm.mm.builder.utils.htmlUtil.hasAttribute(node, "class")){
		cs = com.ibm.mm.builder.utils.htmlUtil.getAttribute(node, "class");
	}
	return cs.replace(/^\s+|\s+$/g, "");	//	string
};

com.ibm.mm.builder.utils.htmlUtil.getClasses = function(/* HTMLElement */node) {
	var c = com.ibm.mm.builder.utils.htmlUtil.getClass(node);
	return (c == "") ? [] : c.split(/\s+/g);	//	array
};

com.ibm.mm.builder.utils.htmlUtil.getChildrenbyClass = function(clzName,parent) {
	var iwidgetsSpan = dojo.query("." + clzName,parent);
	var len = iwidgetsSpan.length;
	var children = [];
	for (var x=0;x<len;x++){
		if (com.ibm.mm.builder.utils.htmlUtil.isDirectChild(iwidgetsSpan[x],parent)){
			children.push(iwidgetsSpan[x]);
		}
	}
	return children;
};

com.ibm.mm.builder.utils.htmlUtil.setUnderlayBgColor = function(){
	var bodyNode = document.getElementsByTagName("BODY")[0];
	var tags = dojo.query(".dijitDialogUnderlay", bodyNode);
	var len =  tags.length;
	for (var k=0;k<len;k++){
		dojo.style(tags[k], {
			background: "black",
			opacity: "0.35",
			filter: "progid:DXImageTransform.Microsoft.Alpha(style=0,opacity=0.35"
		});
	}		
};



// to check if there is any span named iw:iWidget, between child and parent
com.ibm.mm.builder.utils.htmlUtil.isDirectChild = function(child,parent){
	var clzName = child.className;
	var pNode = child.parentNode;
	while (pNode!=parent){
		if (pNode.className == clzName){
			return false;
		}else{
			pNode = pNode.parentNode;
		}
	}
	return true;
};

com.ibm.mm.builder.utils.htmlUtil.getDirectChildrenbyClass = function(clzName,parent) {
	var iwidgetsSpan = dojo.query("." + clzName,parent);
	var len = iwidgetsSpan.length;
	var children = [];
	for (var x=0;x<len;x++){
		if (iwidgetsSpan[x].parentNode == parent){
			children.push(iwidgetsSpan[x]);
		}
	}
	return children;
};

com.ibm.mm.builder.utils.htmlUtil.combineTwoColumn = function(root,left,right){
	if (this.endsWith(root,"/>")){
		root = root.substr(0,root.length - 2);
		root = root + ">\n";
	}else{
		if (this.endsWith(root,"</div>",true)){
			root = root.substr(0,root.length - 6)+"\n";
		}else{
			return "";
		}
	}
	root = root + left;
	root = root + right;
	root = root + "</div>";
	return root;
};

com.ibm.mm.builder.utils.htmlUtil.getElementById = function(parentNode, tagId) {
    var retval = null;
    var childTags = parentNode.getElementsByTagName("*");
    for (var ii=0; ii<childTags.length; ii++) {
        if (childTags[ii].id == tagId) {
            retval = childTags[ii];
            break;
        }
    }
    return (retval);
};
	
com.ibm.mm.builder.utils.htmlUtil.getElementsByClassName = function() {
	var retval = [];
	var searchTags= ["div", "span"];
	for (index=0;index<searchTags.length;index++) {
		els = document.getElementsByTagName(searchTags[index]);
		var elsLen = els.length;
		for (var i=0;i<elsLen; i++) {
			if ( this.widgetClass.test(els[i].className)) {
				retval[retval.length] = els[i];
				
			}
        }
	}
	return retval;
};
	
com.ibm.mm.builder.utils.htmlUtil.getElementString = function(node) {
	var ndiv = document.createElement("div");
	var clonedNode = node.cloneNode(true);
	ndiv.appendChild(clonedNode);
	return ndiv.innerHTML;
};

// Following methods are never called, to be removed.
/*
com.ibm.mm.builder.utils.htmlUtil.addOnclickToElement = function(element,func){
	if (element.attachEvent){
		//IE
		element.attachEvent("onclick",function(){eval(func);}); 
	}else{
		//FF
		element.setAttribute("onclick","javascript:"+func);
	}
};


com.ibm.mm.builder.utils.htmlUtil.removeOnclickFromElement = function(element,func){
	if (element.detachEvent){
		//IE TODO: this does not work, how to detach the onclick event?
		element.detachEvent("onclick",function(){eval(func);});
	}else{
		//FF
		element.removeAttribute("onclick");
	}		
};
*/

com.ibm.mm.builder.utils.htmlUtil.getInclosedWidgets = function(node) {
	var retval = [];
	if (node !== null) {		
		var allWidgets = this.getElementsByClassName();
		if (allWidgets && allWidgets.length>0) {
			for (var index=0;index<allWidgets.length;index++) {
				var aNode = allWidgets[index];
				if (node == this.getWidgetParent(aNode)) {
					retval[retval.length] = aNode;
				}
			}
		}
	}
	return retval;
};

com.ibm.mm.builder.utils.htmlUtil.getChildWidgets = function(/*Node*/selfNode) {
	 var retval = [];
	 if (selfNode) {
	 	var aNode = dojo.byId(selfNode);
		 var childNodes = aNode.childNodes;
		 if (childNodes !== null && childNodes.length > 0) {
			 for (var index=0;index<childNodes.length;index++) {
				 child = childNodes[index];
				 if (child) {
					 if (this.widgetClass.test(child.className)) {
						 retval[retval.length] = child;
					 }
					 else {
						 children = checkChildElement(child);
						 if (children !== null) {
							 for (ii=0;ii<children.length;ii++) {
								 retval[retval.length] = children[ii];
							 }
						 }
					 }
				 }
			 }
		 }
	 }
	 return retval;
};

com.ibm.mm.builder.utils.htmlUtil.checkParentElement = function(/*Node*/selfNode) {
	if (selfNode) {
		var dadNode = selfNode.parentNode;
		if (dadNode) {
			if (dadNode.className) {
				if (this.widgetClass.test(dadNode.className)) {
					return dadNode.id;
				}
			}
			return this.checkParentElement(dadNode);
		}
	}
	return null;
};

com.ibm.mm.builder.utils.htmlUtil.prependChild = function(/*Element*/node, /*Element*/parent){
	//	summary:
	//		prepends node to parent's children nodes
	if(parent.firstChild) {
		parent.insertBefore(node, parent.firstChild);
	} else {
		parent.appendChild(node);
	}
	return true;	//	boolean
};

com.ibm.mm.builder.utils.htmlUtil.disableSelection = function(/*DomNode*/element){
	// summary: disable selection on a node
	element = dojo.byId(element)||dojo.body();
	
	if(dojo.isMoz){
		element.style.MozUserSelect = "none";
	}else if(dojo.isSafari){
		element.style.KhtmlUserSelect = "none"; 
	}else if(dojo.isIE){
		element.unselectable = "on";
	}else{
		return false;
	}
	return true;
};

com.ibm.mm.builder.utils.htmlUtil.getWidgetParent = function(/*String*/id) {
	if (id===null) {
		return null;
	}	   		
	return this.checkParentElement(dojo.byId(id));
};

com.ibm.mm.builder.utils.htmlUtil.setStyle = function() {
	var node = arguments[0];
	for(var i=1; i<arguments.length; i++) {
		stylePair = arguments[i].split(":");
		node.style[stylePair[0]] = stylePair[1];
	}
};
	
com.ibm.mm.builder.utils.htmlUtil.createRadioButton = function(radioName,radioValue,radioOnclick,selected,title){
	var radioString = "<input type='radio' name='";
	radioString = radioString + radioName+ (title ? ("' title='" + title) : "") + "' value='";
	radioString = radioString + radioValue+ "' onclick='";
	radioString = radioString + radioOnclick+ "'";
	if (selected){
		radioString = radioString + " checked>";
	}else{
		radioString = radioString + ">";
	}
	return radioString;
};
	
com.ibm.mm.builder.utils.htmlUtil.getLimitedString = function(text, restrictionNum){
	if(!text) {
		return "";
	}
	if(text.length > restrictionNum){
		text = text.substr(0, restrictionNum) + "...";
	}
	return text;
};

/**
 * @deprecated
 */
com.ibm.mm.builder.utils.htmlUtil.addShadow = function(domNode,classes) {
	for(var i=0; i<classes.length; i++) {
		var div = document.createElement("div");
		div.className = classes[i];
		domNode.appendChild(div);
	}
};

com.ibm.mm.builder.utils.htmlUtil.getSubstitute = function(message, args){
	if(message && args){
		return dojo.string.substitute(message, args);
	}
	return message;
};

com.ibm.mm.builder.utils.htmlUtil.getCurrentStyle =	function (obj, prop) {
	if (obj.currentStyle) {		// IE
		var objStyle = obj.currentStyle[prop];
		if(ibmConfig.fontSizeEnlarged && prop === "fontSize" && objStyle.match(/em/)){
			var p = obj.parentNode;
			var isDialog = false;
			while(p && p.tagName.toLowerCase() != "body"){
				if (dojo.hasClass(p, "dialog_container")) {
					isDialog = true;
					break;
				}
				p = p.parentNode;
			}
			if(isDialog){
				var currentFontSize =parseFloat(objStyle.replace("em",""));
				var enlargedFontSize = parseFloat((p.currentStyle[prop]).replace("em",""));
				objStyle = currentFontSize*enlargedFontSize+"em";
			}
		}
		return objStyle;
	}
	else if (window.getComputedStyle) {	// FF
		prop = prop.replace (/([A-Z])/g, "-$1");
		prop = prop.toLowerCase ();
		return window.getComputedStyle (obj, "").getPropertyValue(prop);
	}
	return null;
};

com.ibm.mm.builder.utils.htmlUtil.createElementWithClass = function (type,classNm,innerHTML){
	var node = document.createElement(type);
	dojo.addClass(node, classNm);
	if(innerHTML){
		node.innerHTML = innerHTML;
	}
	return node;
};

/*
 * get the actually length of string with necessary style 
 */
com.ibm.mm.builder.utils.htmlUtil.getStrWidthByFontStyle = function(str, fontSize, fontFamily, fontWeight){
    if (!this.stringCheckDiv){
    	this.stringCheckDiv = document.createElement("span");
    	this.stringCheckDiv.style.whiteSpace = "nowrap";
    	this.stringCheckDiv.style.position = "absolute";
    	document.body.appendChild(this.stringCheckDiv);
    }
    fontSize = fontSize || this.getCurrentStyle(document.body, "fontSize") || "";
    fontFamily = fontFamily || this.getCurrentStyle(document.body, "fontFamily") || "";
    fontWeight = fontWeight || this.getCurrentStyle(document.body, "fontWeight") || "";
    
	this.stringCheckDiv.style.cssText += "; font-size: " + fontSize
									   + "; font-family: " + fontFamily
									   + "; font-weight: " + fontWeight;
    this.stringCheckDiv.innerHTML = this.formatBlankSpace(str);
    this.stringCheckDiv.style.display = '';
    var w = this.stringCheckDiv.scrollWidth;
    this.stringCheckDiv.style.display = 'none';
    return w;
};

/*
 * get the actually length of string with the node's style and its parents'
 */
com.ibm.mm.builder.utils.htmlUtil.getStrWidth = function(str, node, fontStyle){
	if(fontStyle && fontStyle.fontSize){
		this._fontSize = fontStyle.fontSize;
		this._fontFamily = fontStyle.fontFamily || "Arial,Helvetica,sans-serif";
		this._fontWeight = fontStyle.fontWeight || "normal";
		return this.getStrWidthByFontStyle(str, this._fontSize, this._fontFamily, this._fontWeight);
	}
	if(node){
		this._fontSize = this._fontFamily = this._fontWeight = null;
		while(node && !(this._fontSize && this._fontFamily && this._fontWeight)){
			if (!this._fontSize) {
				this._fontSize = this.getCurrentStyle(node, "fontSize");
			}
			if (!this._fontFamily) {
				this._fontFamily = this.getCurrentStyle(node, "fontFamily");
			}
			if (!this._fontWeight) {
				this._fontWeight = this.getCurrentStyle(node, "fontWeight");
			}
			node = node.parentNode;
		}
	}
	return this.getStrWidthByFontStyle(str, this._fontSize, this._fontFamily, this._fontWeight);
};

/*
 * get the intercepted string with the node's style and its parents' in limited width
 */
com.ibm.mm.builder.utils.htmlUtil.getStrWithLimit = function(str, node, limitWidth, fontStyle){
	if (!str || str.length <= 0 || !limitWidth || limitWidth <= 0) {
		return "";
	}
	var delta = 2;
	var percentage = 0.618;
	var min_str = str.substring(0, 1) + "...";
	var min_width = this.getStrWidth(min_str, node, fontStyle);
	if (limitWidth <= min_width) {
		return min_str;
	}
	var width = this.getStrWidth(str, node, fontStyle);
	if (width < limitWidth) { return str; }
	else {
		var begin = 0;
		var end = str.length;
		while (begin < end) {
			if (end - begin <= delta) {
				while (this.getStrWidth(str.substring(0, begin) + "...") > limitWidth) {
					begin -= 1;
				}
				return (str.substring(0, begin) + "...");
			}
			var index = begin + Math.round((end - begin) * percentage);
			var width_intercepted = this.getStrWidth(str.substring(0, index));
			if (width_intercepted < limitWidth) {
				begin = index;
				end = end;
			}else{
				begin = begin;
				end = index;
			}
		}
	}
};

/*
 * Truncate the string in 'textField' of 'node' and provide the whole string in 'tipField' if necessary.
 */

com.ibm.mm.builder.utils.htmlUtil.truncateAllChildNodesText = function(/* DomNode */node,/* String */tipField,/* obj */fontStyle){
	dojo.forEach(dojo.query(".truncatedLabel",node),function(item){
		com.ibm.mm.builder.utils.htmlUtil.truncateNodeText(item,tipField,fontStyle);
	});
};

com.ibm.mm.builder.utils.htmlUtil.truncateNodeText = function(/* DomNode */node,/* String */tipField, /*obj */fontStyle){

	var	textField ="";
	if(typeof node != 'undefined'){
		textField = (node.tagName.toLowerCase() === "input") ? "value" : "innerHTML";
	}
	else{
		return;
	}
	
	if(!tipField){
		tipField = "title";
	}
	var widthLimit = 0;
	var str = node[textField];
	if(str.length === 0 ){return;}
	if (dojo.hasAttr(node, "widthlimit")) {
		widthLimit = parseInt(dojo.attr(node, "widthlimit"),10);
	}
	else {
		widthLimit = dojo.contentBox(node).w;
		if (widthLimit === 0) {
			widthLimit = parseInt(dojo.style(node,"width"),10);
		}
	}
	if (widthLimit > 0) {
		var shortStr = com.ibm.mm.builder.utils.htmlUtil.getStrWithLimit(str, node, widthLimit,fontStyle);
		if(shortStr.length <= str.length + 2 && !dojo.hasAttr(node,tipField)){
			dojo.attr(node,tipField,this.unEscapeString(str));
		}
		node[textField] = (textField === "innerHTML" && (!dojo.hasAttr(node,"keepBlankSpace"))) ? this.formatBlankSpace(shortStr) : shortStr;
	}
};

com.ibm.mm.builder.utils.htmlUtil.truncateAllChildNodesWord = function(node){
	dojo.forEach(dojo.query(".wordTruncatedLabel",node),function(item){
		com.ibm.mm.builder.utils.htmlUtil.truncateWord(item);
	});
};


com.ibm.mm.builder.utils.htmlUtil.truncateWord = function(node,strContent,widthLimit,ignoreEnlarge){
	// always truncate if set ignoreEnlarge=true
	if(ignoreEnlarge!==true)
		if(ibmConfig.fontSizeEnlarged){ return strContent; }
	
	if( !node ){return strContent;}
	var textType = (node.tagName.toLowerCase() === "input") ? "value" : "innerHTML";
	var str = strContent || node[textType];
	if(str.length === 0){ return strContent; }
	var wordsArr = str.split(" ");
	if (!widthLimit && dojo.hasAttr(node, "widthlimit")) {
		widthLimit = parseInt(dojo.attr(node, "widthlimit"),10);
	}
	var width = widthLimit ? widthLimit : dojo.contentBox(node).w;
	dojo.forEach(wordsArr,function(singleWord,index){
		wordsArr[index] =com.ibm.mm.builder.utils.htmlUtil.getStrWithLimit(singleWord,node,width); 
	});
	var content = wordsArr.join(" ");
	var resultContent = (textType === "innerHTML" && (!dojo.hasAttr(node,"keepBlankSpace"))) ? this.formatBlankSpace(content) : content;
	if(!str){	
		node[textType] = resultContent; 
	} else{
		return resultContent;
	}
	
};

com.ibm.mm.builder.utils.htmlUtil.markTruncation = function(node,widthLimit){
	dojo.addClass(node,"truncatedLabel");
	dojo.attr(node,"widthLimit",widthLimit);
};

/**
 *handle space and line separator 
 */
com.ibm.mm.builder.utils.htmlUtil.formatBlankSpace = function(title){
	if (!title) {
		return "";
	}
	return	title.replace(/\s/g, "&nbsp;");
};

/*
 * This method will replace & with &amp; to avoid incorrect display string &bmp; as an instance.
 * it will handle space as well.
 */
com.ibm.mm.builder.utils.htmlUtil.formatDisplayedContent = function(content, noNeedReplaceAmp, noNeedReplaceNbsp){
	if (!content) {
		return '';
	}
	if (!noNeedReplaceAmp) {
		content = content.replace(/&/g, "&amp;");
	}
	if (!noNeedReplaceNbsp) {
		content = content.replace(/\s/g, "&nbsp;");
	}
	return content;
};

com.ibm.mm.builder.utils.htmlUtil.escapeString = function(content){
	if (!content) {
		return "";
	}
	return content.replace(/&/g,"&amp;").replace(/"/g,"&quot;").replace(/</g,"&lt;").replace(/>/g,"&gt;");
};

com.ibm.mm.builder.utils.htmlUtil.unEscapeString = function(content){
	if (!content) {
		return "";
	}
	return content.replace(/&amp;/g,"&").replace(/&quot;/g,"\"").replace(/&lt;/g,"<").replace(/&gt;/g,">").replace(/&nbsp;/g," ");
};

/**
 * 
 * @param {String} str the message 
 */
com.ibm.mm.builder.utils.htmlUtil.formatMessage = function(str){
	if (!str || str.length <= 0) {
		return "";
	} 
	else {
		var lineSeparatorIndex = str.indexOf("\n");
		if (lineSeparatorIndex > 0) {
			var firstLine = str.substring(0, lineSeparatorIndex);
			var leftLine = str.substring(lineSeparatorIndex);//include '\n'
			return "<div class='firstLineFont truncatedLabel' widthLimit='400'>" + firstLine + "</div><span class='leftLineFont'>" +
			 leftLine.replace(/\n/g, "<br/>")+ "</span>";
		}
		else {
			return str.replace(/\n/g, "<br/>");
		}
	}
};

/**
 * set the title of node
 * @param {String} tileStr the tile of node
 * @param {Object} titleNode the node    
 * @param {Float} limitWidth the width of title
 * 
 */
com.ibm.mm.builder.utils.htmlUtil.setNodeTitle = function(titleStr, titleNode, limitWidth) {
	if (!titleNode || !titleStr) {
		return;
	}
	if(!limitWidth||limitWidth<=0){
		try{
			var valueStr=this.getCurrentStyle(titleNode,"width");
			if(valueStr == "auto") {
				limitWidth = dojo.style(titleNode,"width");
			}
			else if(valueStr.indexOf("%")>-1) {
				limitWidth = dojo.coords(titleNode).w;
			}
			else {
				limitWidth = parseFloat(valueStr.match(/\d*\.?\d*/));
			}
		}catch(e){
			limitWidth = null;
		}
	}
	titleNode.title = "";
    if(!limitWidth||limitWidth=="auto"){
    	titleNode.innerHTML =this.formatBlankSpace(titleStr);
    	return;
    }
	var _title = this.getStrWithLimit(titleStr, titleNode, limitWidth);
	titleNode.innerHTML = this.formatBlankSpace(_title);
	if (titleStr != _title) {
		titleNode.title = this.unEscapeString(titleStr);
	}
};

/**
 * set the title of node with font style
 * @param {String} tileStr, the tile of node
 * @param {Object} titleNode the node    
 * @param {Float} limitWidth, the width of title
 * @param {Map} fontStyle, it should be a map like this <code>{fontSize:"10px", fontFamily:"Sanson", fontWeight:"bold"}</code>
 * 
 */
com.ibm.mm.builder.utils.htmlUtil.setNodeTitleWithStyle = function(titleStr, titleNode, limitWidth, fontStyle) {
	if (!titleNode||!limitWidth||!titleStr||limitWidth<=0||!fontStyle){
		return;
	}
	titleNode.title = "";
	var _title = this.getStrWithLimit(titleStr, titleNode, limitWidth, fontStyle);
	if(titleNode.tagName == "INPUT"){//button
		titleNode.value = _title;
	}else{
		titleNode.innerHTML = this.formatDisplayedContent(_title);
	}
	titleNode.title = titleStr;
};

/**
 * set label and title under such conditions with limited width
 *  node.innerHTML = dojo.string.substitute(label,["<span class=\"youclass\">"+string+"</span>"]);
 */
com.ibm.mm.builder.utils.htmlUtil.setCombinedStringInNode = function(label, content, node, limitedWidth, className){
	var labelWidth = this.getStrWidth(label, node);
	if (labelWidth > limitedWidth) {
		var title = dojo.string.substitute(label, [content]);
		this.setNodeTitle(title, node, limitedWidth);
		return;
	}
	var tempSpan = document.createElement("span");
	tempSpan.className = className;
	node.appendChild(tempSpan);
	var limitedContent = this.getStrWithLimit(content, tempSpan, limitedWidth - labelWidth);
	
	var _content = dojo.string.substitute(label, ["<span class=\"" + className + "\">" + this.formatDisplayedContent(limitedContent) + "</span>"]);
	node.removeChild(tempSpan);
	node.innerHTML = _content;
	if (limitedContent != content) {
		node.title = dojo.string.substitute(label, [content]);
	}
};

/**
 * load a CSS file on the fly.
 */
com.ibm.mm.builder.utils.htmlUtil.loadCss = function(css_url){
	this.loadedCss = this.loadedCss || [];
	
	for(var i=0; i<this.loadedCss.length; i++) {
		var css = this.loadedCss[i];
		if(css == css_url){
			return;
		}
	}
	
	var headID = document.getElementsByTagName("head")[0];         
	var cssNode = document.createElement('link');
	cssNode.type = 'text/css';
	cssNode.rel = 'stylesheet';
	cssNode.href = css_url;
	cssNode.media = 'screen';
	headID.appendChild(cssNode);
			
	this.loadedCss.push(css_url);
};

com.ibm.mm.builder.utils.htmlUtil.removeIframe = function(node){
	if (!node) {
		return;
	}
	var iframe = dojo.query("iframe",node)[0];
	if(iframe){ iframe.parentNode.removeChild(iframe); }
};

com.ibm.mm.builder.utils.htmlUtil.showNodes = function(nodes){
	dojo.forEach(nodes, function(node){
		if (node.style) {
			node.style.display = "";
		}
	});
};

com.ibm.mm.builder.utils.htmlUtil.hideNodes = function(nodes){
	dojo.forEach(nodes, function(node){
		if (node.style) {
			node.style.display = "none";
		}
	});
};

com.ibm.mm.builder.utils.htmlUtil.releaseNode = function(node){
	if (node) {
		try {
			node.onmouseout = null;
			node.onmousemove = null;
			node.onclick = null;
			node.onfocus = null;
			node.onkeypress = null;
			node.innerHTML = "";
		} 
		catch (e) {
		}
	}
};

com.ibm.mm.builder.utils.htmlUtil.uncheckAll = function(pNodes){
	dojo.forEach(pNodes,function(item){
		var inputs = dojo.query("input", item);
		if (inputs) {
			var checkBox = dojo.query("input", item)[0];
			checkBox.checked = false;
		}
	});
};

com.ibm.mm.builder.utils.htmlUtil.getAllCheckedNodes = function(pNode){
	var checkedNodes = [];
	dojo.forEach(pNode.childNodes,function(item){
		var checkBox = dojo.query("input", item)[0];
		if(checkBox.checked){checkedNodes.push(item);}
	});
	return checkedNodes; 
};

//TODO: need to find another better way to fix the bug(scrollbar is hidden by the background in embed dialog)
com.ibm.mm.builder.utils.htmlUtil.showScrollBar = function(widgetId){
	if(widgetId != "layoutwidget"){ return; }
	var rootNode= dojo.byId(widgetId);
	if( !rootNode ){ return; }
	var iframeNode = rootNode.parentNode;
	while(iframeNode){
		if(iframeNode.nodeName.toLowerCase() === "#document"){ break; }
		iframeNode = iframeNode.parentNode;
	}
	if( !iframeNode ){ return; }
	iframeNode = rootNode.parentNode.parentNode.parentNode; 
	if(dojo.isIE && (iframeNode.URL.match(/mycontenthandler/))){
		var rDiv = dojo.query(".mm_Content > div",rootNode)[0];
		if(rDiv){ rDiv.style.position = "static"; }
		var container = dojo.query(".wrapper",rootNode)[0];
		if(container){ container.style.position = "static"; }
	}	
};

/*fix an ie bug: quotes of the attribute's value on a dom will be removed when use innerHTML to get the content.
 *for example: <div title="${key}" /> will be <div title=${key} /> in ie
 */
com.ibm.mm.builder.utils.htmlUtil.addMissingQuoteInTitle = function(str){
	if(!str){ return ""; }
	return str.replace(/title\s*=\s*\${([^}]+)}/g,"title=\"${$1}\""); // JSLINT-IGNORE: 
};

}
