if(!dojo._hasResource["com.ibm.mm.builder.widget.RuntimeResizeWidget"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.widget.RuntimeResizeWidget"] = true;
// @author Laura
// This is a popup dialog that allows a user to set the width and/or height on a widget
// An accessible alternative to com.ibm.pb.layout.resize.WidgetResizer

dojo.provide("com.ibm.mm.builder.widget.RuntimeResizeWidget");
dojo.require("com.ibm.mm.builder.widget.ResizeWidget");
dojo.require("com.ibm.mashups.enabler.model.state.NavigationStateModelFactory");
dojo.require("com.ibm.mashups.enabler.model.state.AccessorFactory");
dojo.require("com.ibm.mashups.enabler.model.state.WidgetAccessor");
dojo.declare("com.ibm.mm.builder.widget.RuntimeResizeWidget",[com.ibm.mm.builder.widget.ResizeWidget],{	
	
	minStyle: {height:"0px",width:"0px"},	 			// the minimum height/width allowed for a skin
	maxStyle: {height:"1000000px",width:"1000000px"},	// the maximum height/width allowed for a skin
	skinId: "",				// the id of the control
	skinNode: null,			// the modifiable runtime skin node
	showHeight: true,		// true if the height input should show
	showWidth: true,		// true if the width input should show
	control: null,			// the DOM node for the control/skin
	bodyClass: "lotusWidgetBody",	// the CSS clas on the widget body present inside the skin
	
	postCreate: function() {
		this.inherited(arguments);
		this.setupDialog(this.skinId,this.showWidth,this.showHeight);
	},
	
	setupDialog: function(skinId, showWidth, showHeight) {
		// summary: update the dialog for the given skin
		// skinId: if of the given skin/control
		// showWidth: true if the width input should be shown
		// showHeight: true if the height input should be shown
		this.skinId = skinId;
		var rsModel = com.ibm.mashups.enabler.runtime.skin.Factory.getRuntimeSkinModel();
		this.skinNode = rsModel.find(this.skinId);
		this.control = com.ibm.pb.layout.LayoutParser.findById(this.skinId);
		// hide the heights or width input if necessary
		this.showWidth = showWidth;
		if (!this.showWidth) {
			dojo.style(this.resizeWidthDiv, "display", "none");
		} else {
			dojo.style(this.resizeWidthDiv, "display", "block");
		}
		this.showHeight = showHeight;
		if (!this.showHeight) {
			dojo.style(this.resizeHeightDiv, "display", "none");
		} else {
			dojo.style(this.resizeHeightDiv, "display", "block");
		}
		this.setupSpinners();
	},
	
	setupSpinners: function() {
		// summary: sets the values and constraints on the width and height input spinners
		
		// calculate the contraints on the height and width by running really small and really big values
		//			for height and width through the style filters so they are reset to reasonable numbers
		var minStyle = dojo.mixin({}, this.minStyle);  this.skinNode.checkStyle(minStyle);
		var maxStyle = dojo.mixin({}, this.maxStyle);  this.skinNode.checkStyle(maxStyle);
		if (this.showHeight) {
			this.widgetHeightInput.constraints = {
				min: parseInt(minStyle.height), 
				max: parseInt(maxStyle.height),
				places: 0
			};
		}
		if (this.showWidth) {
			this.widgetWidthInput.constraints = {
				min: parseInt(minStyle.width), 
				max: parseInt(maxStyle.width),
				places: 0
			};
		}
		
		// set the current height and width as the values in the dialog
		if (this.showHeight) {
			var height = dojo.style(this.control, "height");
			if (height) {
				this.oldHeight = height;
				this.widgetHeightInput.setValue(parseInt(height));
			}
		}
		if (this.showWidth) {
			var width = dojo.style(this.control, "width");
			if (width) {
				this.widgetWidthInput.setValue(parseInt(width));		
			}
		}
		
		// show the dialog
		this.uniDialog.show();
	},
		
	save: function() {
		// summary: save the new height/width to the runtime skin model
		if (this.showWidth && !this.widgetWidthInput.isValid() || this.showHeight && !this.widgetHeightInput.isValid()) {
			return;
		}

		// retrieve the height and/or width inputs
		var style = this.skinNode.getStyle();
		var changes = {};
		if (this.showHeight) {
			var newH = this.widgetHeightInput.getValue();
			this.newHeight = newH;
			changes.height = newH + "px";
		}
		if (this.showWidth) {
			var newW = this.widgetWidthInput.getValue();
			changes.width = newW + "px";
			// get the left value from the DOM instead of "style" in case it's not present in the runtime skin style
			var left = parseInt(dojo.style(this.control).left);
			if (left != Number.NaN && ibmCfg.themeConfig.isRTL) {
				// adjust left style in RTL mode so the widget doesn't jump to the left
				var dx = newW - parseInt(dojo.style(this.control).width);
				changes.left = left - dx + "px";
			}
		}

        // if there is no template url
		// associated with this layout navstate
        // then get it from the page instance
        // and set it here
        var navStateModel = com.ibm.mashups.enabler.model.state.NavigationStateModelFactory.getNavigationStateModel();
        var pageId = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().getID();
        var layoutAccessor =  com.ibm.mashups.enabler.model.state.AccessorFactory.getLayoutAccessor(navStateModel, pageId);

        if (!layoutAccessor.getTemplateURL()) {
            var navNode = com.ibm.mashups.enabler.navigation.Factory.getNavigationModel().find(pageId).start(true);
            var content = navNode.getContent().start(true);
            var templateUrl = content.getStaticContentURL();

            layoutAccessor.setTemplateURL(templateUrl)
        }
		
		// save the new control size in the NavState
		var accessorFactory = com.ibm.mashups.enabler.model.state.AccessorFactory;
		var widgetAccessor = accessorFactory.getWidgetAccessor(navStateModel, this.skinId);
		widgetAccessor.setSize(changes.width, changes.height);
		navStateModel.commit().start();
		
		// save the new style to the runtime skin model and make the page dirty
		this.skinNode.setStyle(dojo.mixin(style, changes));
		com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setDirty(true);
		
		// update the skin UI and close the dialog
		var newWidthHeight = this._updateUI(changes);
		this.hide();
		
		// broadcast the widget change size event to tell the widget it can reflow since its size has changed
		// create a new changes object instead of just using {height:newH,width:newW} 
		//			because if either height or width is null, errors are thrown
		var changes = {"widgetId":this.skinId};
		if (this.showWidth) {
			changes.newWidth = newW;
		} else {	
			// #18723 include width in column layout too
			var box = dojo.contentBox(dojo.query(".lotusWidgetBody",this.control)[0]);
			changes.newWidth = box.w;
		}
		if (this.showHeight && newWidthHeight) {
			changes.newHeight = parseInt(newWidthHeight);
		}
		this.evtSvc.publishEvent(com.ibm.mashups.iwidget.Constants.RESIZE_WIDGET + "." + this.skinId, changes);
		this.evtSvc.publishEvent("com.ibm.mashups.builder.resizeWidget", changes);  // needed for freeform layout
	},
	
	_updateUI: function(style) {
		// summary: set the new height and width in the UI
		// style: a style object {height:"XXpx",width:"YYpx",left:"ZZpx"} to be set on the control
		dojo.style(this.control, style);
		if (this.showHeight) {
			// the height of the widget body must be adjusted to maintain height:100% in the skin
			var widgetNode = dojo.query("."+this.bodyClass, this.control)[0];
			if (widgetNode) {
				var height = parseInt(dojo.style(widgetNode, "height")) - this.oldHeight + this.newHeight + "px";
				this._setWidgetStyle(height);  // Save this new height
				dojo.style(widgetNode, "height", height);
				return height;
			} else {
				return null;
			}
		} else {
			return null;
		}
	},
	
	_setWidgetStyle: function(/*String*/ style) {
		// summary: along with _setWidgetStyleContinue() sets the wrapper-css-style metadata on the control that will get applied to its widget DOM node
		// style: a string that represents the inline style for the widget DOM node
		var navModel = com.ibm.mashups.enabler.navigation.Factory.getNavigationModel();
		var pageId = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().getID();
		var layoutModel = navModel.getLayoutModel(pageId);
		var control = layoutModel.find(this.skinId);
		var me = this;
		control.setFinishedCallback( function(control, status) {
			me._setWidgetStyleContinue(control, status, style);
		}, style);
		control.start(false);
	},
	
	_setWidgetStyleContinue: function(control, status, style) {
		// summary: along with _setWidgetStyle() sets the wrapper-css-style metadata on the control that will get applied to its widget DOM node
		// control: a layout control on which to set the metadata
		// status: the HTTP status result from retrieving the control
		// style: a string that represents the inline style for the widget DOM node
		if (status == 200) {
			control.setMetaData("widget-body-height", style);
		} else {
			console.error("Could not find control when setting wrapper-css-style metadata");
		}
	}
});

}
