if(!dojo._hasResource["com.ibm.widgets.DataTabBar"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.widgets.DataTabBar"] = true;
dojo.provide( "com.ibm.widgets.DataTabBar" );

dojo.require( "com.ibm.widgets.TabBar" );
dojo.require( "com.ibm.widgets.DataMenu" );
dojo.require( "com.ibm.widgets.SelectionModeled" );
dojo.require("dojo.i18n");
dojo.requireLocalization("com.ibm.bundles", "Shelf");


dojo.declare( "com.ibm.widgets.DataTabBar",
			[com.ibm.widgets.TabBar, com.ibm.widgets.SelectionModeled],
			{				
				// tagWidget: String the name of the widget class to instantiate for each
				//		tab in this tab bar.
				tabWidget: "com.ibm.widgets.DataTab",
				
				// menuWidget: String the name of the widget class to instantiate for each
				//		menu associated with the tabs.
				menuWidget: "com.ibm.widgets.DataMenu",
				
				// closeDelay: Number of milliseconds to wait before closing a menu when a tab
				//		and any of its menus are no longer hovered over
				closeDelay: 500,
				
				// openDelay: Number of milliseconds to wait before opening a menu when a tab
				//		is hovered over
				openDelay: 0,
				
				// dndHorizontal: Boolean indicating if this model widget should use horizontal dnd
				//		operations.  True for this widget.
				dndHorizontal: true,
				
				// loadingIndicatorWidget: String name of widget class used to represent the loading state of this 
				// 		modeled widget.  By default, it is displayed as a child of this widget while children 
				// 		are being loaded, and is then removed after loading has completed.
				loadingIndicatorWidget: "com.ibm.widgets.LoadingTab",
				
				// inlineEditorWidget: String name of widget class to use to instantiate the inline
				//		editor of this data backed widget.
				inlineEditorWidget: "com.ibm.widgets.ShowEditorTab",
				
				// showNestedInlineEditor: Boolean indicating whether or not to show the inline editor on 
				//		nested menus, cascading down the tree.  False does not show the inline editor for any
				//		while true shows it for all descendants.
				showNestedInlineEditor: false,
								
				postCreate: function() {
					this.inherited(arguments);
					this.initializeModelWidget();
					this._dndParams.withHandles = true;
					dojo.addClass(this.domNode, "modeledTabs");
					if(this.tabStrip) dojo.addClass(this.tabList, this["class"] + "Strip");
				},
				
				startup: function() {
					this.inherited(arguments);
					this.startupModelWidget();
					this.load();
				},
				
				getInheritableParameters: function(item) {
					return dojo.mixin(this.inherited(arguments), {
						closeDelay: this.closeDelay,
						popupDelay: this.popupDelay,
						showInlineEditor: this.showNestedInlineEditor,
						dndClass: this.dndClass
					});
				},
				handlePreloaded: function() {
					// summary: Plugin point for overrides that handle instantiation of this widget where data
					//		has been provided in the contents of the of the widget itself.
					dojo.forEach(this.getChildren(), function(wij){
						if(this.model.mayHaveChildren(wij.item) || this.showNestedInlineEditor) {
							var popup = this._getPopup(wij.item);
							if(popup) {
								wij.setPopup(popup);
								popup.startup();
							}
						}
					}, this);
					return this.inherited(arguments);
				},
				_getPopup: function(item) {
					if(this.level < this.levels) {
						var menuConstructor = dojo.getObject(this.menuWidget);
						return new menuConstructor(this.getInheritableParameters(item));
					}
					return null;
				},
				createItemRep: function(item) {
					var tabConstructor = dojo.getObject(this.tabWidget);
									
					var args = {
						label: com.ibm.domUtilities.encodeXML(this.model.getLabel(item)),
						iconClass: "dragHandleIcon",
						model: this.model,
						item: item
					};
					if(this.tabClass) {
						args["class"]= this.tabClass;
					}
					if(this.model.mayHaveChildren(item) || this.showNestedInlineEditor) {
						var popup = this._getPopup(item);
						if(popup) args.popup = popup;
					}
					
					var childWidget = new tabConstructor(args);
					childWidget.startup();
					
					// don't load the popup immediately
					// if(childWidget.popup) childWidget.popup.load(); 
					return childWidget; 
				},
				handleChildChildrenChange: function(child, children) {
					// summary: Called when a child that has no children gets children or when a child that has children
					//		loses all its children.
					if(!this.showNestedInlineEditor) {
						if(children.length == 0) {
							// child lost all children, destroy its popup
							child.destroyPopup();
							this.currentPopup = null;
							child.attr("hasChildren", false);
						}
						else if(!child.popup){
							// child without children got new children, create its popup
							var popup = this._getPopup(child.item);
							if(popup) {
								child.setPopup(popup);
								child.attr("hasChildren", true);
								popup.load();
								this.onItemHover(child);
							}
						}
					}
				},
				markSelected: function(childWidget, value) { 
					// summary: Marks the childWidget as selected or unselected depending on the value.
					//		By default, adds/removes the selectedClass to the childWidget's domNode.
					dojo[value ? "addClass" : "removeClass"](childWidget.domNode, this.selectedClass);
					if(childWidget.labelNode){
						if(value){  
							// add a strong tag to a selected child widget
							var children = com.ibm.domUtilities.removeChildren(childWidget.labelNode);
							var selectedLabel = dojo.create("strong", null, childWidget.labelNode);
							children.place(selectedLabel);
							if(this.selectionModel.atLevel(0) == childWidget.item){
								var hiddenText = dojo.create("span", {innerHTML: this.currentlySelected, className: "ibmPortalHiddenText ibmHiddenText wpthemeAccess"});
								selectedLabel.appendChild(hiddenText);
							}
						} else { 
							// remove a strong tag from a unselected child widget
							var label = dojo.query("strong",childWidget.labelNode); 
							if(label[0]) {
								var children = com.ibm.domUtilities.removeChildren(label[0]);
								children.place(childWidget.labelNode);
								dojo.destroy(label[0]);
							} 
						}
					}
				},
				onItemFocus: function(child) {
					if(child.popup) child.popup.load();
					this.inherited(arguments);
				},
				onItemHover: function(child, evt) {
					if(child.popup) child.popup.load();
					this.inherited(arguments);
				},
				onItemClick: function(child, evt) {
					if(child.attr("disabled")) return false; 
					child.onClick(evt);
					if(child.item) this.onModelItemClick(child, child.item);
				}
			}
);

dojo.declare("com.ibm.widgets.DataTab",
			com.ibm.widgets.Tab,
			{
				_setHasChildrenAttr: function(value) {
					this.hasChildren = value;
					dojo[value ? "addClass" : "removeClass"](this.domNode, "modelHasChildren");
				},
				_setDndStatusAttr: function(value) {
					this.dndStatus = value;
					if(this.popup) {
						this.popup[value ? "setupDnd" : "disableDnd"]();
					}
				},
				item: null	// type is string so we can process parsed attributes as strings
			}
);

dojo.declare( "com.ibm.widgets.LoadingTab",
			com.ibm.widgets._TabBase,
			{
				templatePath: dojo.moduleUrl("com.ibm.widgets", "templates/LoadingTab.html"),
				
				"class": "loadingTab lotusTab",
				
				iconClass: "ibmLoading",
				
				label: "Loading...",
				
				postMixInProperties: function() {
					this.shelfBundle = dojo.i18n.getLocalization("com.ibm.bundles", "Shelf");
					this.label=this.shelfBundle["shelf_loading"];
				},
				
				attributeMap: dojo.mixin(dojo.clone(dijit._Widget.prototype.attributeMap), {
					label: {node: "labelNode", type: "innerHTML"},
					iconClass: {node: "iconNode", type: "class" }
				}),
				
				isFocusable: function() {
					// loading tabs are not focusable because they provide no actionable
					// content and are simply indicators of an unready or pending status
					return false;
				}
			}
);

}
