/** Licensed Materials - Property of IBM, 5724-U69, (C) Copyright IBM Corp. 2009, 2010 - All Rights reserved.  **/

if(!dojo._hasResource['com.ibm.widgets.TemplateSelectDialog']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['com.ibm.widgets.TemplateSelectDialog'] = true;
dojo.provide('com.ibm.widgets.TemplateSelectDialog');
dojo.require("dojo.i18n");
dojo.require('com.ibm.widgets.ResourceSelectDialog');
dojo.require("dojox.atom.io.model");
dojo.require("dojox.atom.io.Connection");
dojo.requireLocalization("com.ibm.bundles", "Shelf", null, "ROOT,ar,ca,cs,da,de,el,en,es,fi,fr,he,hr,hu,it,ja,ko,nl,no,pl,pt,pt-br,ro,ru,sk,sl,sv,th,tr,uk,zh,zh-tw");
dojo.requireLocalization("com.ibm.bundles", "PageCreatorDialog", null, "ROOT,ar,ca,cs,da,de,el,en,es,fi,fr,he,hr,hu,it,ja,ko,nl,no,pl,pt,pt-br,ro,ru,sk,sl,sv,th,tr,uk,zh,zh-tw");
dojo.declare('com.ibm.widgets.TemplateSelectDialog',
	[com.ibm.widgets.ResourceSelectDialog],
    {
		
								
		postMixInProperties: function() {
			this.inherited(arguments);
			
			// override the UI dialog strings
			this.nlsResourceSelectTitle = this.dialogBundle["page_dialog_select_template"];
			this.nlsPersonLabel = this.dialogBundle["template_dialog_owned_by"];
			this.nlsNoUser = this.dialogBundle["template_dialog_no_owner"];
			this.nlsResourceTableSummary = this.dialogBundle["template_dialog_table_summary"];
			this.nlsSearchResourcesLabel = this.dialogBundle["template_dialog_search_templates"];
                
            this.feedQueryUrl = "?uri=nm%3Aoid%3Awps.content.template.root&levels=100";
		},	
        // Override to use our processing methods and strings
        _populateResourceSelector: function () {
            var aNode = this.resourceSelector;
                
            this.selectorWidget = new com.ibm.widgets.ResourceSelector({
                feedQueryUrl: this.feedQueryUrl,
                entryStartIndex: 1,  // skip over first entry as it should be parent page templates node, we want the rest
                _getUserDataForEntry: this._getUserDataForEntry,
                _processEntryResultsBeforeStoring: this._processEntryResultsBeforeStoring,
                nlsPersonLabel: this.nlsPersonLabel,
                nlsNoUser: this.nlsNoUser,
                nlsResourceTableSummary: this.nlsResourceTableSummary,
                nlsSearchResourcesLabel: this.nlsSearchResourcesLabel
            },aNode);
        },
        // Override to get the owner data associated with a template atom entry
        _getUserDataForEntry: function(atomIO, entry) {
            
            var rv = null;
            var getHref = this._getHref;
            
            // to get author info, first need to get the content model for this entry
            var relAttr = null;
            if (dojo.isOpera) {
                relAttr = "content";
            }
            var contentHref = getHref(entry, com.ibm.widgets.TemplateSelectDialog.CONTENT_MODEL_SCHEMA, relAttr);
            if (contentHref) {
                contentHref = ibmPortalConfig.contentHandlerURI + contentHref;
                // have to use getFeed call here rather than getEntry or it won't work on IE
                atomIO.getFeed(contentHref, function(feed) {
                    var entries = feed.entries;
                    var contentEntry = entries[0];
                    // now get the ac resource url
                    if (dojo.isOpera) {
                        relAttr = "ac-resource-config";
                    }
                    var acResourceHref = getHref(contentEntry, com.ibm.widgets.TemplateSelectDialog.RESOURCE_CONFIG_SCHEMA, relAttr);
                    if (acResourceHref) {

                        atomIO.getEntry(acResourceHref, function(accessEntry) {
                            // see if an owner is specified
                            if (accessEntry && accessEntry.content && accessEntry.content.value) {
                                var value = accessEntry.content.value;
                                var startPos = value.indexOf("ac:DN=\"");
                                // just grab the dn of the owner
                                if (startPos > -1) {
                                    startPos += 7;
                                    var stopPos = value.indexOf("\"", startPos);
                                    if (stopPos > startPos) {
                                        rv = value.substring(startPos, stopPos);
                                    }
                                }
                            }
                        });

                    }
                });
            }
            return rv;
        },
        // Override to clean up the id data associated with a template atom entry
        _processEntryResultsBeforeStoring: function(data){
            if (data) {
                // get id, strip off schema
                var _id = data.id;
                data.id = this._stripOffPrefix(_id, com.ibm.widgets.TemplateSelectDialog.NAVIGATION_MODEL_SCHEMA);
                
                // set selection
                var selectedId = this.selectedResourceId;
                var _selected = false;
                // has a prior selection been made at all?
                if (selectedId && selectedId.length > 0 && (selectedId === _id)) {
                    data.selected = true;
                }
            }
            return data;
        }
    }
);

com.ibm.widgets.TemplateSelectDialog.NAVIGATION_MODEL_SCHEMA = "nm:oid:";
com.ibm.widgets.TemplateSelectDialog.CONTENT_MODEL_SCHEMA = "cm:oid:";
com.ibm.widgets.TemplateSelectDialog.RESOURCE_CONFIG_SCHEMA = "resourceconfig:oid:";
}
