dojo.provide("com.ibm.mm.builder.systemwidget.NewPageDialog");

dojo.require("com.ibm.pb.iwidget.iWidgetBase");
dojo.require("com.ibm.widgets.NewPageDialog");
dojo.require("com.ibm.pb.customize.LotusWaitingDialog");

dojo.declare("com.ibm.mm.builder.systemwidget.NewPageDialog", [com.ibm.pb.iwidget.iWidgetBase], {
	
	controller: null,
	showFriendlyURL: false,
	allowFriendlyURL: false,
	showMakePrivate: false,
	showPageTemplate: false,
	newPage: false,
	ROLETYPE_PRIVILEGED_USER: "Privileged User",
	
	onLoad: function() {
		var mname = "onLoad", lgr = this.LOGGER;
		lgr.entering(mname, arguments);
		this.wid = "_"+this.iContext.widgetId+"_";
		var attrMix = this.getItemSetValues([
			"controller",	// Object
			"showFriendlyURL","allowFriendlyURL", "showMakePrivate", "showPageTemplate"	// Boolean
		]);
		if(typeof attrMix["showPageTemplate"] =="object" || typeof attrMix["showPageTemplate"] =="string")
		{
			this.convertMapTypes(attrMix, ["controller","showPageTemplate"], "Object");
			this.convertMapTypes(attrMix, ["showFriendlyURL","allowFriendlyURL", "showMakePrivate"], "Boolean");
		}
		else
		{
			this.convertMapTypes(attrMix, ["controller"], "Object");
			this.convertMapTypes(attrMix, ["showFriendlyURL","allowFriendlyURL", "showMakePrivate", "showPageTemplate"], "Boolean");
		}
		if(attrMix["allowFriendlyURL"]==true)
		{
			attrMix["showFriendlyURL"]=attrMix["allowFriendlyURL"];
		}
		dojo.mixin(this, attrMix);
		this.model = this.controller.getTreeModel();
		this.nm = com.ibm.mashups.enabler.navigation.Factory.getNavigationModel();
		this.nsm = com.ibm.mashups.enabler.model.state.NavigationStateModelFactory.getNavigationStateModel();
		lgr.exiting(mname, arguments);
	},
	onUnload: function() {
		this._cleanupInternalWidget();
	},
	_cleanupInternalWidget: function() {
		if(this.widget) {
			if(this._changeConnection) {
				dojo.disconnect(this._changeConnection);
			}
			this.widget.destroy();
		}
	},
	_initInternalWidget: function() {
		var me = this;
		this._cleanupInternalWidget();
		var showMakePrivate = this.showMakePrivate && this._canMakePrivateChild(this._parentId) && this._canMakePublicChild(this._parentId);
		this.widget = new com.ibm.widgets.NewPageDialog({
			beforeSubmit: function() {
				if(!dojo.isOpera || dojo.isOpera >= 9.8){ 
					me.waitDlg = new com.ibm.pb.customize.LotusWaitingDialog({
						message: this.dialogBundle.page_dialog_page_being_created,
						spinner: builderConfig.builderPath + "/images/loading.gif"
					});
					setTimeout(function(){me.waitDlg.show();},this.duration);
				}
			},
			showMakePrivate: showMakePrivate,
			canMakePrivate: this._canMakePrivateChild(this._parentId),
			canMakePublic: this._canMakePublicChild(this._parentId),
			showPageTemplate: this.showPageTemplate,
			showFriendlyURL: this.showFriendlyURL
		}, this.iContext.getElementById(this.wid + "contents"));
		this._changeConnection = dojo.connect(this.widget, "onChange", this, "_onChange");
		this.widget.startup();
	},
	_canMakePrivateChild: function(parentId) {
		var parentNode = this.nm.find(parentId).start();
		var ret = false;
		if(parentNode) {
			var spaceAccessor = com.ibm.mashups.enabler.model.state.AccessorFactory.getSpaceAccessor(this.nsm);
			ret = parentNode.hasRole(this.ROLETYPE_PRIVILEGED_USER) && (!ibmCfg.portalConfig.projectUUID || ibmCfg.portalConfig.projectUUID === "null") && !spaceAccessor.getSpaceID();
		}
		return ret;
	},
	_canMakePublicChild: function(parentId) { 
		var parentNode = this.nm.find(parentId).start();
		var ret = false;
		if(parentNode) {
			ret = parentNode.hasRole(this.roleTypes.EDITOR) && !this._isPrivate(parentNode);
		}
		return ret;
	},
	_isPrivate: function(navNode) {
		var isPrivate = false;
		if(navNode) {
			var xml = navNode.getXml(),
				expr = "./atom:content/*/ac:allowed-access[@ac:private='true']";
			isPrivate = com.ibm.mashups.enabler.xml.XPath.evaluateBoolean(expr, xml, {
				app: "http://www.w3.org/2007/app",
				atom: "http://www.w3.org/2005/Atom",
				ac: "http://www.ibm.com/xmlns/prod/lotus/access-control/v1.0"
			});
		}
		return isPrivate;
	},
	_onChange: function(value) {
		var mname = "_onChange", lgr = this.LOGGER, me = this;
		lgr.entering(mname, arguments);
		var parentItem = this.nm.find(this._parentId).start();
		lgr.trace(mname, "Creating new node under ${0} ${1}", [this._parentId, parentItem]);
		value.callback = function(page, mode, status, params) {
			if(me.waitDlg) {
				me.waitDlg.cancel();
			}
		}
		this.model.newItem(value, parentItem);
		lgr.exiting(mname, arguments);
	},
	onCreatePage: function(iEvent) {
		var mname = "onCreatePage", lgr = this.LOGGER;
		lgr.entering(mname, arguments);
		this.newPage = true; 
		if(this.widget && this.widget.open) { return; }
		this._parentId = iEvent.payload.parentPageId;
		this._spaceId = iEvent.payload.spaceId;
		this._initInternalWidget();
		this.widget.focus();
		lgr.exiting(mname, arguments);
	},
	onTemplateSelectChanged: function(iEvent) {
		var mname = "onTemplateSelectChanged", lgr = this.LOGGER;
		lgr.entering(mname, arguments);
		this.widget._templateSelectChanged(iEvent.payload);
		lgr.exiting(mname, arguments);
	},	
	onPageSwitched: function(iEvent){
		if(this.newPage){
			this.newPage = false, me = this, duration = this.widget ? this.widget.duration : 200;
			if(this.waitDlg){
				setTimeout(function(){me.waitDlg.hide();},duration);
			}
		}
	}
});
