/* Copyright IBM Corp. 2015  All Rights Reserved.                    */
dojo.provide("com.ibm.mashups.enabler.model.ServiceDocumentModel");

//<INTERFACE>
/**
 * An singleton that represents the Service Document
 * 
 * @ibm-spi
 * @ibm-module Base
 *
 * This value defines the order in which the packages should be printed out into the dojo profile. Default is 100.
 * Any number that is smaller causes this class to be written out before any other with a higher number
 * @ibm-dojo-profile-level 50
 */

dojo.declare("com.ibm.mashups.enabler.model.ServiceDocumentModel", null,
    {
        /**
         * Constant representing the navigation service
         * @type {String} 
         */
        SERVICE_NAVIGATION: "navigation",
        /**
         * Constant representing the space navigation service
         * @type {String} 
         */
        SERVICE_SPACE_NAVIGATION: "space-navigation",
        /**
         * Constant representing the shared navigation service
         * @type {String} 
         */
        SERVICE_SHARED_NAVIGATION: "shared-navigation",
        /**
         * Constant representing the content service
         * @type {String} 
         */
        SERVICE_CONTENT: "content",
        /**
         * Constant representing the catalog service
         * @type {String} 
         */
        SERVICE_CATALOG: "catalog",
        /**
         * Constant representing the resource service
         * @type {String} 
         */
        SERVICE_RESOURCE: "resource",
        /**
         * Constant representing the widget service
         * @type {String} 
         */
        SERVICE_WIDGET: "widget",
        /**
         * Constant representing the theme service
         * @type {String} 
         */
        SERVICE_THEME: "theme",
        /**
         * Constant representing the user service
         * @type {String} 
         */
        SERVICE_USER: "user",
        /**
         * Constant representing generic model services
         * @type {String} 
         */
        SERVICE_MODEL: "model",
        /**
         * Constant representing multipart services
         * @type {String} 
         */
        SERVICE_MULTIPART: "multipart",
        /**
         * Constant representing the huffman encoding of multipart services
         * @type {String} 
         */
        SERVICE_HUFFMAN: "huffman",
        /**
         * Constant representing the sitemap encoding of multipart services
         * @type {String} 
         */
        SERVICE_SITEMAP: "sitemap",
        /**
         * Constant representing the commit handler sitemap encoding of multipart services
         * @type {String} 
         */
        SERVICE_SITEMAP_COMMITHANDLER: "commit-handler",
        /**
         * Constant representing the composite application service
         * @type {String} 
         */
        SERVICE_COMPOSITE: "composite-applications",
        /**
         * Constant representing the space service
         * @type {String} 
         */
        SERVICE_SPACE: "application",
        /**
         * Constant representing the space favorites service
         * @type {String} 
         */
        SERVICE_SPACE_FAVORITE: "application-favorite",
        /**
         * Constant representing the template service
         * @type {String} 
         */
        SERVICE_TEMPLATE: "template",
        /**
         * Constant representing the config service
         * @type {String} 
         */
        SERVICE_CONFIG: "config",
        /**
         * Constant representing the webdav filestore
         * @type {String} 
         */
        SERVICE_FILESTORE: "filestore",
        /**
         * Constant representing generic webdav services
         * @type {String} 
         */
        SERVICE_WEBDAV: "webdav",
        
        /**
         * Invalidates the Service Document Model in order for it to be re-initialized again.
         * 
         * @type void
         */
        invalidate: function() {
        },
        /**
         * Returns a two-dimensional array of IDs representing services which are attached to a specific endpoint namespace.
         * The IDs in the second dimension are required to lookup the service data.<br/>
         * Example: [["webdav"],["filestore"]]<br/>
         * Only the combination of both IDs make the service unique and must be used to lookup the service data
         * 
         * @Returns {String[][]} A two-dimensional array with the second dimension being a list of IDs which represent the service.
         */
        getModelCollections: function() {
        },
        /**
         * Returns a two-dimensional array of IDs representing services which are attached to mashups specifically.
         * The IDs in the second dimension are required to lookup the service data.<br/>
         * Example: [["webdav"],["filestore"]]<br/>
         * Only the combination of both IDs make the service unique and must be used to lookup the service data
         * 
         * @return {String[][]} A two-dimensional array with the second dimension being a list of IDs which represent the service.
         */
        getMashupsCollections: function() {
        },
        /**
         * Returns a JSON object for a given collection link in the service document. Not all elements are mandatory.<br/>
         * JSON format<br/>
         * { id: "the id array",<br/>
         * url :"the url",<br/>
         * template :"the template",<br/>
         * idprefix: "id|oid",<br/>
         * namespaces : { "base" : "base-url", "model" : "model-url", "ext" : "ext-url", "creation-context" : "creation-context-url" },<br/>
         * accept: "accept MIME type",<br/>
         * version: "major.minor"<br/>
         * }<br/>
         * @param {String[]} idArray The ID Array to lookup the service for.
         * @type Object
         * @return {Object} Returns a JSON object for a given collection link in the service document
         */
        getCollectionData: function(idArray) {
        }
    }
);
//</INTERFACE>

dojo.require("com.ibm.mm.enabler.model.ServiceDocumentModel");
