/* Copyright IBM Corp. 2015  All Rights Reserved.                    */
dojo.provide("com.ibm.mashups.enabler.model.state.WidgetAccessor");

//<INTERFACE>
dojo.require("com.ibm.mashups.enabler.model.state.Accessor");
/**
 * Interface representing a WidgetAccessor. Reserved Widget Paramers:
 * "cp" : the reserved paremeter for widget customized state.
 * "h"  : the reserved paremeter for widget height.
 * "w"  : the reserved paremeter for widget width.
 * "st" : the reserved paremeter for widget window state. 
 * "md" : the reserved paremeter for widget mode. 
 * @ibm-spi
 * @ibm-module Base
 */
dojo.declare( "com.ibm.mashups.enabler.model.state.WidgetAccessor", [com.ibm.mashups.enabler.model.state.Accessor], {
    /**
      * @private
      */
    constructor:function (navStateModel, id) {
    },
	/**
     * Returns the widget id of the Widget
     * @type String
     * @return {String} ID of required Widget
     */
	getWidgetID:function() {
	},
	/**
     * Returns the values of the required widget state parameter. If state has only one value, this method returns a single array with a length of 1. 
     * 
     * @since 2.4
     * @param {String} key The name of the required parameter of Widget Navigation State
     * 				   "cp" is the reserved parameter for widget customized state.
     * @type String
     * @return {String[]} Values of required parameter
     */
	getWidgetStateValues:function(key) {
	},
		/**
     * Returns the state of the required widget state parameter
     * @param {String} key The name of the required parameter of Widget Navigation State
     * 				   "cp" is the reserved parameter for widget customized state.
     * @type String
     * @return {String} Value of required parameter
     */
	getWidgetState:function(key) {
	},
	/**
     * Set the value of a widget state parameter
     * 
     * @since 2.4
     * @param {String} key The name of the required parameter 
     * @param {String[]} values The values of the required parameter
     * @type WidgetAccessor
     * @return{WidgetAccessor} return an handle of WidgetAccessor upon successful, <code>null</code> upon failure.
     */
	setWidgetState:function(key,values){
	},
	/**
     *  Confirms whether setting the values for the given widget state parameter is possible.
     * 
     * @since 2.4
     * @param {String} key The name of the required parameter 
     * @param {String[]} values The values of the required parameter
     * @type Boolean
     * @return {Boolean} true if the values can be set, otherwise false.
     */
	confirmSetWidgetState:function(key,values){
		return true;
	},
	/**
     * Set the value of a widget state parameter
     * 
     * @since 2.4
     * @param {String} key The name of the required parameter 
     * @param {String} value The value of the required parameter
     * @type WidgetAccessor
     * @return{WidgetAccessor} return an handle of WidgetAccessor upon successful, <code>null</code> upon failure.
     */
	setWidgetState:function(key,value){ // JSLINT-IGNORE: in Java functions with the same name but different signatures are allowed - this is only used for generating JavaDoc
	},
	/**
     *  Confirms whether setting the value for the given widget state parameter is possible.
     * 
     * @since 2.4
     * @param {String} key The name of the required parameter 
     * @param {String} value The value of the required parameter
     * @type Boolean
     * @return {Boolean} true if the value can be set, otherwise false.
     */
	confirmSetWidgetState:function(key,value){// JSLINT-IGNORE: in Java functions with the same name but different signatures are allowed - this is only used for generating JavaDoc
		return true;
	},
	/**
     * Remove a widget state parameter
     * @param {String} key The name of the required parameter 
     * @type WidgetAccessor
     * @return{WidgetAccessor} return an handle of WidgetAccessor upon successful, <code>null</code> upon failure.
     */
	removeWidgetState:function(key){
	},
	/**
     * Confirms whether removing a widget state parameter is possible
     *  
     * @since 2.4
     * @param {String} key The name of the required parameter 
     * @type Boolean
     * @return{Boolean} return true if the required parameter can be removed
     */
	confirmRemoveWidgetState:function(key){
		return true;
	},
	/**
     * Returns the names of custimized widget state
     * @type String[]
     * @return {String[]} an array of customized widget state names
     */
	getWidgetStateNames:function(){
	},	
	/**
     * Returns the mode of the required widget 
     * @type String
     * @return {String} The mode of the required widget and <code>null</code> if no mode is set yet.
     */
	getWidgetMode:function() {
	},
	/**
     * Set the mode of a widget
     * @param {String} mode of the required widget 
     * @type WidgetAccessor
     * @return{WidgetAccessor} return an handle of WidgetAccessor upon successful, <code>null</code> upon failure.
     */
	setWidgetMode:function(mode) {
	},
	/**
     * Confirms whether it's possible or not to set the widget to a new mode
     * @param {String} mode of the required widget 
     * @type Boolean
     * @return{Boolean} return true if it's possible to set widget to the new model
     */
	confirmSetWidgetMode:function(mode) {
		return true;
	},
	/**
     * Returns the window state of the required widget 
     * @type String
     * @return {String} The window state of the required widget following states are allowed: "normal","minimize","maximize". It returns <code>null</code> if no windowstate is set yet.
     */
	getWindowState:function() {
	},
	/**
     * Set the window state of a widget
     * @param {String} windowState The window state of the required widget 
     * @type WidgetAccessor
     * @return{WidgetAccessor} return an handle of WidgetAccessor upon successful, <code>null</code> upon failure.
     */
	setWindowState:function(windowState) {
	},
	/**
     * Confirms whether it's possible or not to set the widget to a new window state
     * @param {String} windowState The window state of the required widget  
     * @type Boolean
     * @return{Boolean} return true if it's possible to set widget to the new window state
     */
	confirmSetWindowState:function(windowState) {
		return true;
	},
	/**
     * Returns the size of the required widget 
     * @type Object
     * @return {Object} A JSON object representing the widget width/height, for example: <code>{w:"200",h:"400"}</code>
     */
	getSize:function() {
	},
	/**
     * Set the size of a widget
     * @param {String} width The width of the widget 
     * @param {String} height The height of the widget 
     * @type WidgetAccessor
     * @return{WidgetAccessor} return an handle of WidgetAccessor upon successful, <code>null</code> upon failure.
     */
	setSize:function(width, height) {
	},
	/**
     * Confirms whether it's possible or not to set the widget to the new width and height
     * @param {String} width The width of the widget 
     * @param {String} height The height of the widget 
     * @type Boolean
     * @return{Boolean} return true if it's possible to set widget to the new width and height
     */
	confirmSetSize:function(width,height) {
		return true;
	},
   /**
	* "minimize" window state supported by enabler
	* @type String
	*/ 
	MIN: "minimize",
  /**
	* "maximize" window state supported by enabler
	* @type String
	*/ 
    MAX: "maximize",
 /**
	* "normal" window state supported by enabler
	* @type String
	*/ 	
    NORMAL: "normal"

});
//</INTERFACE>
dojo.require("com.ibm.mm.enabler.model.state.WidgetAccessorImpl");

