/* Copyright IBM Corp. 2015  All Rights Reserved.                    */
/**
 * @author Tong Li (litong01@us.ibm.com)
 * @author Marshall (shiwcsdl@cn.ibm.com)
 */
dojo.require("dojox.validate.web");

dojo.declare("com.ibm.mm.widget.htmlFragment._WB_VER_.v201",null,{

	WID:null,
	
	rootFrame:null,
	
	resourceBundle:null,
	
	ID_VURLOBJ: 'vUrl',
	
	// #18752
	iframe_saving_flag: false,
	
    // URL Dijit parameters
    _urlDijitClass: "com.ibm.mashups.widget.dijit.url.v104",
    _urlWidgetHelper: null,         // holds reference to Widget Helper of URL dijit
    _urlDijit: null,
	_onChangeUrlConnect: null,

    onLoad: function () {
	    dojo.registerModulePath("com.ibm.mm.widget.htmlFragment._WB_VER_.v201", this.iContext.io.rewriteURI("js"));
		dojo.registerModulePath(this._urlDijitClass, this.iContext.io.rewriteURI("urlDijit"));
		
		var cs=com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.enabler.services.ConfigService.SERVICE_NAME);
		dojo.requireLocalization("com.ibm.mm.widget.htmlFragment._WB_VER_.v201", "widgetStr", cs.getValue("locale"), cs.getValue("availableLocales"));
        
        try {
            this.resourceBundle = dojo.i18n.getLocalization("com.ibm.mm.widget.htmlFragment._WB_VER_.v201", "widgetStr");
        } 
        catch (e) {
            dojo.requireLocalization("com.ibm.mm.widget.htmlFragment._WB_VER_.v201", "widgetStr", cs.getValue("default.locale"), cs.getValue("availableLocales"));
            this.resourceBundle = dojo.i18n.getLocalization("com.ibm.mm.widget.htmlFragment._WB_VER_.v201", "widgetStr");
        } 		
		
		dojo['require'](this._urlDijitClass + "._base");
		
        var url = this.getMigratedURL();
		
		var hubUrl = com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.enabler.services.ConfigService.SERVICE_NAME).getValue(com.ibm.mashups.enabler.services.ConfigConstants.HUB_URL);
		
		// instantiate the Widget Helper
        this._urlWidgetHelper = new (dojo.getObject(this._urlDijitClass).WidgetHelper)({
			migrateUrl: url || "",
            iContext: this.iContext,
            openSearchUrl: hubUrl + '/atom?nologin=true',
            attributeKey: this.ID_VURLOBJ,
            // onLoadUrl: dojo.hitch(this, this.onLoadButtonClick),
			hideLoadButton: true,
			hideBrowseButton: true,
			autoSave: false,
			noForm: false,
			legend: this.resourceBundle.I_HTMLFRAGMENT_TYPE_URL
        });
        
		this.WID = "_" + this.iContext.widgetId + "_";
	},

    onUnload: function() {
				this.WID = null;
				this.rootFrame = null;
	},
				
	onView:function(){
		var rootNode = this.iContext.getRootElement();
		
		this.rootFrame = this.iContext.getElementById(this.WID + "rootFrame");
		dojo.attr(this.rootFrame, "title", this.resourceBundle.I_HTMLFRAGMENT_IFRAME_TITLE);
		
		var contentNode = dojo.byId(rootNode.id + "_content");
		if (contentNode) {
			this.doResize();
		}
		
		dojo.byId(this.WID+"default_message").innerHTML = this.resourceBundle.I_HTMLFRAGMENT_CONF_URL_DISPALY;
		
		// # 17436: disable this will make the 'first' cancel saving also adding the url param
//        if (this._urlWidgetHelper && this._urlWidgetHelper.initialized) {
//            this._urlWidgetHelper.reload();
//        } 
		//var theUrl = this._urlWidgetHelper.getUrl();
		var theUrl = this.getMigratedURL();
        if (theUrl) {
			if(dojo.isSafari == 4){
				var widgetParentNode = this.iContext.getRootElement().parentNode;
				dojo.style(widgetParentNode,"overflow","visible");
			}
			try{
				this.resetSrc(this.rootFrame,this.filterURI(theUrl));
			}catch(e){
				alert(this.resourceBundle.I_HTMLFRAGMENT_CANTLOAD_URL);
				return;
			}
			this.rootFrame.style.display = "";
			dojo.byId(this.WID+"default_message").style.display="none";
			
			var att = this.iContext.getiWidgetAttributes();
			var theHeight = att.getItemValue('defaultheight');
			if (theHeight != null && theHeight != "" && !isNaN(theHeight)) {
				this.rootFrame.style.height = theHeight + "px";
			} else {
				this.rootFrame.style.height = "300px";
			}
		} else {
			this.rootFrame.style.display = "none";
			dojo.byId(this.WID+"default_message").style.display="";
		}
		
		dojo.disconnect(this._onChangeUrlConnect);
    	this._onChangeUrlConnect = dojo.connect(this._urlWidgetHelper, "onUpdateUrl", this, "handleChangedUrl");
	},
	
	onEdit:function(){
		try { 
			this.resetSrc(this.rootFrame,"");
		} catch (e) {}
		
		var defaultHeightId = this.WID+"defaultheight";
		
		if (dojo.hasClass(dojo.body(),"mumrtl")){
			dojo.byId(defaultHeightId).style.textAlign = "right";
		}
		
		dojo.byId(this.WID+"type_defaultheight_text").innerHTML = this.resourceBundle.I_HTMLFRAGMENT_TYPE_HEIGHT;
		dojo.attr(dojo.byId(this.WID+"defaultheight"),"title",this.resourceBundle.I_HTMLFRAGMENT_TYPE_HEIGHT);				
		this.byId(this.WID+"btn_apply").value = this.resourceBundle.I_SYSTEM_MESSAGE_APPLY;
		dojo.attr(this.byId(this.WID+"btn_apply"),"title",this.resourceBundle.I_SYSTEM_MESSAGE_APPLY);
		this.byId(this.WID+"cancel_text").innerHTML = this.resourceBundle.I_COMMON_CANCEL;
		dojo.attr(this.byId(this.WID+"cancel_text"),"title",this.resourceBundle.I_COMMON_CANCEL);
		
		if (this._urlDijit) {
			if (this._urlDijit.destroyRecursive)
				this._urlDijit.destroyRecursive(true);
			delete this._urlDijit;
            this._urlDijit=null;
		}
        dojo.disconnect(this._onChangeUrlConnect);
        
		var theUrl = this.getMigratedURL();
        this._urlWidgetHelper.setUrl(theUrl);
		
        if (!this._urlDijit) {
            // initialize URL dijit
            this._urlDijit = this._urlWidgetHelper.initializeDijit(this.byId(this.WID + "urlDijitDiv"));
        }
        if (this.messageControl) {
			this.messageControl.hide();
		}
		this._urlDijit.onBlur = dojo.hitch(this, function(){
			if (!dojo.query("UrlValidationTextBox", this.byId(this.WID + "urlDijitDiv")).value) {
				dojo.query(".dijitValidationIcon", this.byId(this.WID + "urlDijitDiv")).attr("title", this.resourceBundle.I_HTMLFRAGMENT_TYPE_URL);
				dojo.query(".dijitValidationIcon", this.byId(this.WID + "urlDijitDiv")).attr("aria-invalid","true");
				dojo.query(".dijitValidationIcon", this.byId(this.WID + "urlDijitDiv")).attr("role", "alert");
			} else{
				dojo.query(".dijitValidationIcon", this.byId(this.WID + "urlDijitDiv")).attr("aria-invalid","false");
				dojo.query(".dijitValidationIcon", this.byId(this.WID + "urlDijitDiv")).attr("role", null);
			}
		});
        
        this._onChangeUrlConnect = dojo.connect(this._urlWidgetHelper, "onUpdateUrl", this, "handleChangedUrl");

		
		var att = this.iContext.getiWidgetAttributes();
		if (att != null) {
			var defaultHeight = parseInt(att.getItemValue("defaultheight"));
			if (defaultHeight == null || defaultHeight == ""){ 
				defaultHeight = 300;
			}
			dojo.byId(defaultHeightId).value = defaultHeight;			
		}	
	},
    
    onConfig: function(){
        this.onEdit();
    },
    
    onPersonalize: function(){
        this.onEdit();
    },
    
	resetSrc: function(/*DOMNode*/iframe, /*String*/src){
		try{
			iframe.location = src;
			iframe.src = src;
		}catch(e){ 
			console.log("resetSrc: ", e);
			throw e;
		}
	},
		
    /**
     * Prevent XSS attach
     * @param {String} url url to be encoded
     */
    filterURI: function(url) {
		if (dojo.isString(url)) {
			// filter "javascript:" and "vbscript:"
	        var regex = new RegExp("[ \t\n\x0B\f\r]*(((j|&#106;|&#x6A;|&#0000106;)[ \t\n\x0B\f\r]*(a|&#97;|&#x61;|&#0000097;)[ \t\n\x0B\f\r]*(v|&#x76;|&#118;|&#0000118;)[ \t\n\x0B\f\r]*(a|&#97;|&#x61;|&#0000097;))|((v|&#x76;|&#118;|&#0000118;)[ \t\n\x0B\f\r]*(b|&#x62;|&#98;|&#0000098;)))[ \t\n\x0B\f\r]*(s|&#x73;|&#115;|&#0000115;)[ \t\n\x0B\f\r]*(c|&#x63;|&#99;|&#0000099;)[ \t\n\x0B\f\r]*(r|&#x72;|&#114;|&#0000114;)[ \t\n\x0B\f\r]*(i|&#x69;|&#105;|&#0000105;)[ \t\n\x0B\f\r]*(p|&#x70;|&#112;|&#0000112;)[ \t\n\x0B\f\r]*(t|&#x74;|&#116;|&#0000116;)[ \t\n\x0B\f\r]*(:|&#x3A;|&#58;|&#0000058;)", "i");
			return regex.test(url) ? "" : url;
		} else {
			return "";
		}
    },
    
    onURLReceived: function(iEvent) {
		var obj = iEvent.payload;	
		
		if(dojo.isString(obj)){
			if(obj.indexOf("http") != 0 && obj.indexOf("https") != 0){
				obj = "";
				dojo.byId(this.WID+"default_message").innerHTML=this.resourceBundle.I_HTMLFRAGMENT_CANTLOAD_URL;
				return;
			}
		}
		this.rootFrame.src = this.filterURI(obj);
		this.showWebSiteByURL(obj);
	},
    
    /**
     * Get dom node by id in iWidget
     * @param {String|DomNode} id
     */
    byId: function(id){
        if(!id) return null;
		var mode = this.iContext.widgetwrapper.currentMode;
		if(mode=="edit" || mode=="personalize" || mode=="config")
			id = id + "_" + mode;
        return this.iContext.getElementById(this.domID + id) || this.iContext.getElementById(id);
    },
    
	handleChangedUrl: function(url) {
		if (this.iframe_saving_flag) {
			// don't change iframe src when saving
			this.iframe_saving_flag = false;
		} else {
			var _url = this.filterURI(url);
			this.rootFrame.src = _url
			this.showWebSiteByURL(_url);
		}
	},
	
	/**
	 * Show website
	 * @param {String} url
	 */
	showWebSiteByURL: function(url) {
		this.rootFrame.style.display = "";
		dojo.byId(this.WID+"default_message").style.display="none";
//		this.rootFrame.src = this.filterURI(url);
		
		if(dojo.isSafari) {
			var contentNode = dojo.byId(this.WID.substring(1)+"content");
			if (contentNode){
					if(!contentNode.style.height)		
							contentNode.style.height = "300px";
			}		
		}
		this.doResize();
	},
	
	cancelInput:function(){
		this.iContext.iEvents.fireEvent("onModeChanged",null,{newMode:'view'});
	},
	
	saveURL:function() {
		if (this.iContext.getiDescriptor().getItemValue("mode") != this.iContext.constants.mode.VIEW) {
			this.iframe_saving_flag = true;
			var mode = this.iContext.widgetwrapper.currentMode;
			var urlDijitId = "_" + this.iContext.widgetId + "_urlDijitDiv_" + mode;
			if (dijit.byId(urlDijitId)){
				dijit.byId(urlDijitId)._onUrlInputChange();
			}
			// allow empty URL
			var url = this._urlWidgetHelper.getUrl() || "";
			
			if (this.isValidUrl(url)==false){
				this._showMessage(this.resourceBundle.I_HTMLFRAGMENT_ERROR_INVALID_URL,"error");
				return;
			}
			 
			var attr = this.iContext.getiWidgetAttributes();
			attr.setItemValue("url", url);
			// migrate 30: set vUrl to null -- depreciate it to make the getMigratedURL work
			if(attr.getItemValue(this.ID_VURLOBJ) != null) {
				attr.setItemValue(this.ID_VURLOBJ, null);	
			}
			
			var defaultHeightElement = dojo.byId(this.WID + "defaultheight");		
			if (defaultHeightElement != null) {
				var height = defaultHeightElement.value-0;
				if (isNaN(height)) {
					alert(this.resourceBundle.I_HTMLFRAGMENT_ERROR_INVALID_HEIGHT);
					dojo.attr(defaultHeightElement,"aria-invalid","true");
					return;			
				}
				dojo.attr(defaultHeightElement,"aria-invalid","false");		
				attr.setItemValue("defaultheight", height );
			}
			
			attr.save();
	
	 		// this._urlWidgetHelper.save();  // //this line of code introduced additional post request and caused the error described in 18650
			
			this.iContext.iEvents.fireEvent("onModeChanged",null,{newMode:'view'});
		}
	},
	
	_showMessage : function(message, type) {
		if(!this.messageControl){
			var url = this.iContext.io.rewriteURI(
				ibmConfig["com.ibm.mashups.contextroot"] + "/dijit-library/oneUI.versionized/messages");
			dojo.registerModulePath("com.ibm.lotus.oneui.v100.messages", url);
			dojo.require("com.ibm.lotus.oneui.v100.messages.Message");
		}
		if (this.messageControl) {
			this.messageControl.destroy();
			delete this.messageControl;
			this.messageControl = null;
		}
		var node = this.iContext.getElementByClass("errorMessage")[0];
		var messageNode = dojo.create("div",null,node);
		this.messageControl = new com.ibm.lotus.oneui.v100.messages.Message({messageType: 'error'}, messageNode);
		this.messageControl.attr({"message" : message,"messageType" : type || "error"});
		this.messageControl.show();
	}, 
	
	isValidUrl:function(url){
		if (url == "") {
			return true;
		}
		if (url == "about:blank"){
			return true;
		}
		if (url.indexOf('\\\\') == 0){
			return true;
		}		
		// allow full server url
		if (url.indexOf('/') === 0) {
			url = "http://localhost" + url;
		}
		// validate url
		if (url.indexOf("http") === 0) {
			return dojox.validate.isUrl(url, {allowLocal: true, allowNamed: true});	
		}
		// validate file
		if (url.indexOf("file:") === 0) {
			return true;
		}
		// default to false
		return false;	
	},

	doResize:function() {
		var rootNode = this.iContext.getRootElement();
		if (dojo.byId(rootNode.id + "_content")){
			var contentNode = dojo.byId(rootNode.id + "_content");
			contentNode.style.overflow='hidden';		
			var cw=contentNode.style.width;
			//if(cw==null||cw==""){
				cw="100%";
			//}else{
			//	cw=parseInt(contentNode.style.width)-3+"px";
			//}
			this.rootFrame.style.width=cw;
			
			var ch=contentNode.style.height;
			if(ch==null||ch==""){
				ch="100%";
			}else{
				ch=parseInt(contentNode.style.height)-3+"px";
			}
			this.rootFrame.style.height=ch;			
		} 
	},
	
	onSizeChanged: function(iEvent){
		if(this.iContext.getiDescriptor().getItemValue("mode") != this.iContext.constants.mode.VIEW){
			var contentNode = this.byId(this.WID + "contentNode");
			var contentMarginBox = dojo.marginBox(contentNode);
			var dialogContentBox = dojo.contentBox(contentNode.parentNode);
			var footerMarginBox = dojo.marginBox(this.byId(this.WID + "footer"));
			
			contentMarginBox.h = dialogContentBox.h - footerMarginBox.h;
			contentMarginBox.w = dialogContentBox.w;
			dojo.marginBox(contentNode, contentMarginBox);
		} else {
			var payload = iEvent.payload;
			// will always keeps the width 100% so that maximize & change container width can work
//			if (payload.newWidth){
//				dojo.style(this.rootFrame, {width: parseInt(payload.newWidth) + "px"});
//			}
			if (payload.newHeight){
				dojo.style(this.rootFrame, {height: (parseInt(payload.newHeight) -3) + "px"});
			}
		}
	},
	
	_unloadIframe : function(elem) {
        if (elem && elem.attachEvent) {
            elem.src = "";
            elem.attachEvent("onload", function() {
                elem.outerHTML = "";
                elem = null;
            });
        }
    },
    
    onUnload : function() {
        this._unloadIframe(this.rootFrame);
		if (this._urlDijit) {
			if (this._urlDijit.destroyRecursive)
				this._urlDijit.destroyRecursive(true);
			delete this._urlDijit;
            this._urlDijit=null;
		}
		this.rootFrame = null;
    },
	
	// migrate 3.0: 3.0 website displayer save the URL in 'vUrl' attribute
	// 3001 website do not save vURL to attributes, it's null
	getMigratedURL: function() {
		var att = this.iContext.getiWidgetAttributes();
		var vUrl = att.getItemValue(this.ID_VURLOBJ);
		var theUrl = "";
		if (vUrl==null) {	// we are in 3001
			theUrl = att.getItemValue("url");
		} else {	// we are migrated from 3.0
			var urlObj = dojo.fromJson(vUrl);
			var theUrl = urlObj["baseURL"];
			var params = urlObj["parameters"];
			if(params.length>0) {
				theUrl += "?"
				for (var i=0,j=params.length; i<j; i++) {
  					var param = params[i];
  					var p = param["paramName"] + "=" + param["defaultValue"];
  					theUrl += p;
  					if(i<j-1)
    					theUrl += "&";
				}
			}
		}
		return theUrl;
	}
});
